SystemOrganization addCategory: #NautilusCommon!
SystemOrganization addCategory: #'NautilusCommon-Announcements'!
SystemOrganization addCategory: #'NautilusCommon-Plugin'!
SystemOrganization addCategory: #'NautilusCommon-Plugin-Manager'!
SystemOrganization addCategory: #'NautilusCommon-Refactor'!
SystemOrganization addCategory: #'NautilusCommon-TestCaseAnnouncements'!
SystemOrganization addCategory: #'NautilusCommon-Plugin-JannikAlgo'!

Trait named: #MalTGraphBuilder
	uses: {}
	category: 'NautilusCommon-Plugin-JannikAlgo'!

!MalTGraphBuilder methodsFor: 'private' stamp: 'simon.denier 9/27/2010 17:37'!
addEdge: eModel from: source to: target 

	| edge sourceNode targetNode unknownNode |
	unknownNode := false.
	sourceNode := self 	findNode: (source value: eModel)
							ifAbsent: [ unknownNode := true ].
	targetNode := self 	findNode: (target value: eModel)
							ifAbsent: [ unknownNode := true ].

	unknownNode ifFalse: [
		self edgeClass ifNil: [
			sourceNode to: targetNode.
			targetNode from: sourceNode.
			^ nil
		] ifNotNil: [
			edge := self edgeClass with: eModel.
			sourceNode to: targetNode edge: edge.
			targetNode from: sourceNode edge: edge.
			edge from: sourceNode.
			edge to: targetNode.
			self edges add: edge.	
			^ edge
		]		
	].
	^ nil! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:33'!
edgeClass

	^ nil! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:34'!
edges
	
	self explicitRequirement! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:37'!
edges: aCollection from: source to: target

	aCollection do: [ :eModel |
		self addEdge: eModel from: source to: target
	]! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:34'!
edges: aCollection from: source to: target weight: weightFunction

	| edge |
	aCollection do: [ :eModel |
		edge := self addEdge: eModel from: source to: target.
		edge ifNotNil: [edge weight: (weightFunction value: eModel)].
	]! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:37'!
edges: aCollection from: source toAll: targets

	aCollection do: [ :eModel |
		(targets value: eModel) do: [:target| 
			self addEdge: {source value: eModel. target} from: #first to: #second
		]
	]! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:34'!
findEdge: aModel

	^ self edges detect: [:edge | edge model = aModel]! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:34'!
findNode: aModel

	^ self nodes detect: [:aNode | aNode model = aModel ]! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:35'!
findNode: aModel ifAbsent: aBlock

	^ self nodes detect: [:node | node model = aModel] ifNone: aBlock! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:35'!
graph

	^ {self nodes. self edges}! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/30/2010 14:46'!
nodeClass

	^ MalGraphNode! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:35'!
nodes
	
	self explicitRequirement! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:35'!
nodes: aCollection

	aCollection do: [ :model |
		self nodes add: (self nodeClass with: model)
	]
! !

Trait named: #MalTNodeNode
	uses: {}
	category: 'NautilusCommon-Plugin-JannikAlgo'!

!MalTNodeNode methodsFor: 'accessing' stamp: 'simondenier 2/8/2010 22:14'!
from: sourceNode

	self previousNodes add: sourceNode ! !

!MalTNodeNode methodsFor: 'accessing' stamp: 'simondenier 2/8/2010 22:15'!
nextNodes

	self explicitRequirement! !

!MalTNodeNode methodsFor: 'accessing' stamp: 'simondenier 2/8/2010 22:14'!
previousNodes

	self explicitRequirement! !

!MalTNodeNode methodsFor: 'accessing' stamp: 'simondenier 2/8/2010 22:14'!
to: targetNode

	self nextNodes add: targetNode ! !

Trait named: #MalTNormalize
	uses: {}
	category: 'NautilusCommon-Plugin-JannikAlgo'!

!MalTNormalize methodsFor: 'running' stamp: 'simondenier 3/17/2010 22:26'!
normalize: aCollectionOfNodes

	| firstNode perm |
	firstNode := aCollectionOfNodes detectMin: [:n| n printString ].
	perm := aCollectionOfNodes copy.
	[ firstNode = perm first ] whileFalse: [
		perm addLast: perm removeFirst ].
	^ perm! !

!RGTraitDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 9/1/2011 09:38'!
inheritsFrom: aClass

	^ self realClass inheritsFrom: aClass! !

StandardWindow subclass: #NautilusWindow
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon'!

!NautilusWindow commentStamp: '<historical>' prior: 0!
I am a subclass of StandardWindow with my own icon

Maybe I'm useless, but right now I'm not on the top of the to do list!

!NautilusWindow methodsFor: 'open/close' stamp: 'BenjaminVanRyseghem 8/25/2011 09:33'!
delete
	
	| mod |
	mod := self model.
	super delete.
	mod announce: (NautilusClosedAnnouncement window: self)! !

!NautilusWindow methodsFor: 'thumbnail' stamp: 'BenjaminVanRyseghem 4/5/2011 14:22'!
icon

	^ NautilusUI icon! !

!NautilusWindow methodsFor: 'open/close' stamp: 'BenjaminVanRyseghem 4/11/2011 17:43'!
initialExtent

	^ 700@500! !

!SystemNavigation methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 5/31/2011 17:09'!
browseSharedPoolUsersOf: aClass

	| pattern list | 
	self okToChange ifFalse: [^ self ].
	list := self allClassesUsingSharedPool: aClass name.
	list isEmpty
		ifTrue: [ ^ self ]
		ifFalse: [pattern := UIManager default 
				enterOrRequestFrom: list 
				lines: #() 
				title: 'Class name or fragment?'].

	pattern isNil ifTrue: [^ self ].
	pattern browse! !

!SystemNavigation methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/23/2011 22:31'!
browsedEnvironment: aBrowserEnvironment

	environment := aBrowserEnvironment asSystemNavigationEnvironment! !

!SystemNavigation methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 3/22/2011 15:53'!
selectorFromPattern: pattern withCaption: aCaption startingFrom: aClass
	"I look after a selector matching the given pattern in the withSuperclasses of the given class"

	| toMatch potentialSelectorsList potentialSelectorsListNames methodsNames exactMatch index foundSelector separatorIndex className separatorName class |
	(toMatch := pattern
		copyWithoutAll:
			{(Character space).
			(Character cr).
			(Character tab)}) isEmpty
		ifTrue: [ ^ nil ].
	potentialSelectorsList := aClass withAllSuperclasses reverse gather: [:each | each methodDict ].
	Symbol
		hasInterned: toMatch
		ifTrue: [ :patternSymbol || result |
			"Exact symbol provided"
			result := OrderedCollection new.
			potentialSelectorsList do: [:each | 
				(each selector = patternSymbol)
				ifTrue: [result add: each]].
			result size = 1 ifTrue: [^ result first ]].
	toMatch := (toMatch copyWithout: $.) asLowercase.
	potentialSelectorsListNames := potentialSelectorsList collect: [:each | each methodClass name, '>>#', each selector ].
	methodsNames := pattern last = $.
		ifTrue: [ potentialSelectorsListNames select: [ :nm | nm asLowercase = toMatch ] ]
		ifFalse: [ potentialSelectorsListNames select: [ :n | n includesSubstring: toMatch caseSensitive: false ] ].
	methodsNames isEmpty
		ifTrue: [ ^ nil ].
	exactMatch := methodsNames detect: [ :each | each asLowercase = toMatch ] ifNone: [ nil ].
	index := methodsNames size = 1
		ifTrue: [ 1 ]
		ifFalse: [ 
			exactMatch
				ifNil: [ UIManager default chooseFrom: methodsNames lines: #() title: aCaption ]
				ifNotNil: [ 
					methodsNames addFirst: exactMatch.
					UIManager default chooseFrom: methodsNames lines: #(1) title: aCaption ] ].
	index = 0
		ifTrue: [ ^ nil ].
	foundSelector := methodsNames at: index.
	separatorIndex := foundSelector findString: '>>#'.
	className := foundSelector copyFrom: 1 to: separatorIndex-1.
	separatorName := foundSelector copyFrom: separatorIndex + 2 to: foundSelector size.
	class := Smalltalk at: (Symbol readFromString: '#',className).

	
	^ class methodDict at: (Symbol readFromString: separatorName)
"
	self default selectorFromPattern: 'op' withCaption: '' startingFrom: Boolean
	self default selectorFromPattern: 'zork' withCaption: '' startingFrom: Boolean
	self default selectorFromPattern: 'op' withCaption: '' startingFrom: NautilusWindow
	self default selectorFromPattern: 'openInWorld' withCaption: '' startingFrom: NautilusWindow
"! !

!SystemMethodModifiedAnnouncement methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/1/2011 16:03'!
item

	^ event item! !

!SystemMethodModifiedAnnouncement methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/1/2011 16:02'!
oldItem

	^ event oldItem! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:46'!
containsFlag

	^ self literals includesAnyOf: #( flag flag: ).! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:44'!
containsHalt
	
	^ self literals includesAnyOf: #( halt halt: halt:onCount: haltIf: haltIfNil haltIfShiftPressed haltOnCount: haltOnce haltOnce:)! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:43'!
correspondingMethods
	" retrieve methods that could be the corresponding method "

	self isTestMethod
		ifTrue: [| className selector selectors |
			selector := self selector.
			className := self methodClass name.
			(self methodClass inheritsFrom: TestCase)
				ifTrue: [| classSymbol correspondingClass correspondingSel result |
					(selector beginsWith: 'test')
						ifFalse: [ ^ {}].				
					(className endsWith: 'Test')
						ifTrue: [ classSymbol := className copyFrom: 1 to: (className size - 4) ]
						ifFalse: [ classSymbol := className ].
					classSymbol := Symbol readFromString: '#', classSymbol.
					correspondingClass := self class environment at: classSymbol ifAbsent: [ ^ {} ].
					correspondingSel := selector copyFrom: 5 to: selector size.
					selectors := correspondingClass selectors.
					result := selectors select: [:each | (each asLowercase = correspondingSel asLowercase) or: [ each asLowercase = (correspondingSel,':') asLowercase]].
					^ result collect: [:each| correspondingClass >> each ]]
				ifFalse: [^ {}]]
		ifFalse: [ ^ { self}  ]! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:49'!
correspondingTestMethod

	self isTestMethod
		ifTrue: [ ^ self ]
		ifFalse: [| sel testClass |
			(self selector endsWith: ':')
				ifTrue: [ sel := self selector allButLast asLowercase ]
				ifFalse:[  sel := self selector asLowercase ].
			(sel beginsWith: 'test')
				ifFalse: [ sel := 'test', sel].
			^ ((testClass := self methodClass correspondingForTest) = self methodClass)
				ifTrue: [ nil ]
				ifFalse:[
					( testClass methodDict values 
								detect: [:each | each selector asLowercase = sel ]
								ifNone: [ nil ]) asRingDefinition ]]! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 23:11'!
hasErrorTest

	^ self methodClass methodRaisedError: (self selector)! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 23:11'!
hasFailedTest

	^ self methodClass methodFailed: (self selector)! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:52'!
hasPassedTest

	^ self methodClass methodPassed: (self selector)! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 23:12'!
isFromTrait

	^ self methodClass hasTraitComposition and: [self methodClass traits anySatisfy: [:trait| (trait selectors includes: self selector) and: [ ((trait >> self selector) decompile sourceText) = self sourceCode]]]! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:51'!
isOverride
	
	self methodClass allSuperclasses do: [:each | 
		(each selectors includes: self selector)
			ifTrue: [ ^true ]].
	^ false! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:50'!
isOverriden
	
	self methodClass allSubclasses do: [:each | 
		(each selectors includes: self selector)
			ifTrue: [ ^true ]].
	^ false
	! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:42'!
isTestMethod

	^ (self methodClass inheritsFrom: TestCase) and: [ self selector beginsWith: 'test' ]! !

!RGMethodDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 9/1/2011 09:40'!
literals
	
	"bad code but I do not know how to properly retrieve the good compiled method using a RGMethodDefinition"


	^ self compiledMethod literals.! !

!Trait methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/23/2011 21:40'!
correspondingForTest
	"Return the unit test that correspond to me. If it does not exist, it returns myself. 
	 Return the tested class if sent to a class"
	
	| symbol |
	^ (self inheritsFrom: TestCase)
		ifTrue: [ 
			| i |
			i := self name indexOfSubCollection: 'Test'.
			symbol := Symbol readFromString: ('#', self name copyReplaceAll: 'Test' with: '' ).
			Smalltalk at: symbol ifAbsent: [ self ]]
		ifFalse: [
			symbol := Symbol readFromString: ('#', self name, 'Test').
			Smalltalk at: symbol ifAbsent: [ self ]]! !

!Trait methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 5/12/2011 11:28'!
protocol
	" start to migrate to RING API "

	^ self category! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/7/2011 18:51'!
containsFlag

	^ self literals includesAnyOf: #( flag flag: ).! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/7/2011 18:50'!
containsHalt

	^ self literals includesAnyOf: #( halt halt: halt:onCount: haltIf: haltIfNil haltIfShiftPressed haltOnCount: haltOnce haltOnce:).! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:43'!
correspondingMethods
	" retrieve methods that could be the corresponding method "

	self isTestMethod
		ifTrue: [| className selector selectors |
			selector := self selector.
			className := self methodClass name.
			(self methodClass inheritsFrom: TestCase)
				ifTrue: [| classSymbol correspondingClass correspondingSel result |
					(selector beginsWith: 'test')
						ifFalse: [ ^ {}].				
					(className endsWith: 'Test')
						ifTrue: [ classSymbol := className copyFrom: 1 to: (className size - 4) ]
						ifFalse: [ classSymbol := className ].
					classSymbol := Symbol readFromString: '#', classSymbol.
					correspondingClass := self class environment at: classSymbol ifAbsent: [ ^ {} ].
					correspondingSel := selector copyFrom: 5 to: selector size.
					selectors := correspondingClass selectors.
					result := selectors select: [:each | (each asLowercase = correspondingSel asLowercase) or: [ each asLowercase = (correspondingSel,':') asLowercase]].
					^ result collect: [:each| correspondingClass >> each ]]
				ifFalse: [^ {}]]
		ifFalse: [ ^ { self } ]! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/21/2011 18:21'!
correspondingTestMethod

	self isTestMethod
		ifTrue: [ ^ self ]
		ifFalse: [| sel testClass |
			(self selector endsWith: ':')
				ifTrue: [ sel := self selector allButLast asLowercase ]
				ifFalse:[  sel := self selector asLowercase ].
			(sel beginsWith: 'test')
				ifFalse: [ sel := 'test', sel].
			^ ((testClass := self methodClass correspondingForTest) = self methodClass)
				ifTrue: [ nil ]
				ifFalse:[ testClass methodDict values detect: [:each |
					each selector asLowercase = sel ] ifNone: [ nil ]]]! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/7/2011 18:10'!
hasErrorTest

	^ self methodClass methodRaisedError: (self selector)! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/7/2011 18:11'!
hasFailedTest

	^ self methodClass methodFailed: (self selector)! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/7/2011 18:11'!
hasPassedTest

	^ self methodClass methodPassed: (self selector)! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/23/2011 18:44'!
isFromTrait

	^ self methodClass hasTraitComposition and: [self methodClass traits anySatisfy: [:trait| (trait selectors includes: self selector) and: [ ((trait >> self selector) decompile sourceText) = self decompile sourceText]]]! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 5/10/2011 10:46'!
isOverride
	
	self methodClass allSuperclasses do: [:each | 
		(each selectors includes: self selector)
			ifTrue: [ ^true ]].
	^ false! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 5/10/2011 11:05'!
isOverriden
	
	self methodClass allSubclasses do: [:each | 
		(each selectors includes: self selector)
			ifTrue: [ ^true ]].
	^ false
	! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 5/10/2011 11:11'!
isOverriden2
	
	| implementors subclasses methodClass |
	implementors := SystemNavigation default allImplementorsOf: self selector.
	implementors := implementors collect: [:each | each methodClass ].
	subclasses := self methodClass allSubclasses.
	methodClass := self methodClass.
	^ (subclasses size > implementors size)
		ifTrue: [ implementors anySatisfy: [:each | each inheritsFrom: methodClass]]
		ifFalse: [ subclasses includesAnyOf: implementors ]! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/6/2011 17:43'!
isTestMethod

	^ (self methodClass inheritsFrom: TestCase) and: [ self selector beginsWith: 'test' ]! !

!CompiledMethod methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 5/12/2011 11:28'!
protocol
	" start to migrate to RING API "

	^ self category! !

!SystemClassRenamedAnnouncement methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/1/2011 17:51'!
newName
	
	^ self event newName! !

!SystemClassRenamedAnnouncement methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/1/2011 17:50'!
oldName
	
	^ self event oldName! !

Announcement subclass: #ATestHasBeenRun
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-TestCaseAnnouncements'!

!ATestHasBeenRun classSide methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 17:39'!
result: aResult

	^ self new result: aResult! !

!ATestHasBeenRun methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 17:39'!
result

		^ result! !

!ATestHasBeenRun methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 17:39'!
result: anObject
	
		result := anObject! !

Announcement subclass: #NautilusBooleanAnnouncement
	instanceVariableNames: 'boolean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

!NautilusBooleanAnnouncement class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/12/2011 11:21'!
boolean: aBoolean

	^ self new boolean: aBoolean! !

!NautilusBooleanAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2011 11:21'!
boolean

		^ boolean! !

!NautilusBooleanAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2011 11:21'!
boolean: anObject
	
		boolean := anObject! !

NautilusBooleanAnnouncement subclass: #NautilusShowCategoriesChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

NautilusBooleanAnnouncement subclass: #NautilusShowCommentChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

NautilusBooleanAnnouncement subclass: #NautilusShowGroupsChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

NautilusBooleanAnnouncement subclass: #NautilusShowHierarchyChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

NautilusBooleanAnnouncement subclass: #NautilusShowInstanceChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

NautilusBooleanAnnouncement subclass: #NautilusShowPackagesChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

Announcement subclass: #NautilusCategorySelected
	instanceVariableNames: 'category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

!NautilusCategorySelected class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/10/2011 17:17'!
category: anObject
	
	^ self new category: anObject! !

!NautilusCategorySelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 17:16'!
category

		^ category! !

!NautilusCategorySelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 17:16'!
category: anObject
	
		category := anObject! !

Announcement subclass: #NautilusClassSelected
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

!NautilusClassSelected class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/10/2011 14:48'!
class: aClass

	^ self new class: aClass! !

!NautilusClassSelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 14:45'!
class: anObject
	
		class := anObject! !

!NautilusClassSelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 14:47'!
itemClass

	^ class! !

Announcement subclass: #NautilusGroupSelected
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

!NautilusGroupSelected class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/10/2011 14:48'!
group: aGroup

	^ self new group: aGroup! !

!NautilusGroupSelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 14:46'!
group

		^ group! !

!NautilusGroupSelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 14:46'!
group: anObject
	
		group := anObject! !

Announcement subclass: #NautilusKeyPressed
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

!NautilusKeyPressed class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 5/10/2011 12:26'!
key: aKey

	^ self new key: aKey! !

!NautilusKeyPressed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/4/2011 14:16'!
key

		^ key! !

!NautilusKeyPressed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/4/2011 14:16'!
key: anObject
	
		key := anObject! !

Announcement subclass: #NautilusMethodSelected
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

!NautilusMethodSelected class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/10/2011 14:49'!
method: aMethod

	^ self new method: aMethod! !

!NautilusMethodSelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 14:45'!
method

		^ method! !

!NautilusMethodSelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 14:45'!
method: anObject
	
		method := anObject! !

Announcement subclass: #NautilusPackageSelected
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

!NautilusPackageSelected class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/10/2011 12:28'!
package: aPackage

	^ self new package: aPackage! !

!NautilusPackageSelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/4/2011 14:15'!
package

		^ package! !

!NautilusPackageSelected methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/4/2011 14:15'!
package: anObject
	
		package := anObject! !

Announcement subclass: #NautilusWindowAnnouncement
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

NautilusWindowAnnouncement subclass: #NautilusClosedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

NautilusWindowAnnouncement subclass: #NautilusOpenedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

!NautilusWindowAnnouncement class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 8/24/2011 18:53'!
window: aWindow

	^ self new window: aWindow! !

!NautilusWindowAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/24/2011 18:53'!
window

	^ window! !

!NautilusWindowAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/24/2011 18:53'!
window: anObject
	
	window := anObject! !

!ClassEnvironment methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 3/25/2011 17:02'!
packages

	^ (self classes gather: [:each | each packages]) asSet! !

!RGBehaviorDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 9/1/2011 14:41'!
addCategory: newName before: aCategory

	^ self addProtocol: newName! !

!RGClassDescriptionDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 9/1/2011 14:39'!
extendingPackages

	^ self realClass extendingPackages! !

!Behavior methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 9/1/2011 14:42'!
addCategory: newName before: aCategory

	^ self organization addCategory: newName before: aCategory! !

!Behavior methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 9/5/2011 18:20'!
protocols
	
	^ self organization categories copy! !

IconicButton subclass: #ToogleIconicButton
	instanceVariableNames: 'model statusSelector enabledIcon disabledIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon'!

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:41'!
balloonText

	^ helpText! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:05'!
borderRaised
	self borderStyle: (BorderStyle raised width: 0).! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:12'!
disabledIcon

		^ disabledIcon! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:36'!
disabledIcon: anObject
	
		disabledIcon := anObject.
		self updateStatus.! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:12'!
enabledIcon

		^ enabledIcon! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:36'!
enabledIcon: anObject
	
		enabledIcon := anObject.
		self updateStatus.! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:08'!
extraBorder

	^ 0! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 16:26'!
getStatus

	self model 
		ifNotNil: [:mod | 
			self statusSelector
				ifNotNil:[:selector | 
					^ mod perform: selector ]].
	^ true! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:08'!
labelGraphic: aForm
	"Changed to look for any image morph rather than just a sketch."
	
	| oldLabel |
	graphicalMorph ifNotNil: [graphicalMorph delete].
	graphicalMorph := ImageMorph new image: aForm.
	self extent: graphicalMorph extent + (self borderWidth + self extraBorder).
	graphicalMorph position: self center - (graphicalMorph extent // 2).
	self addMorph: graphicalMorph.
	graphicalMorph lock
! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:25'!
model

	^ model! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 17:10'!
model: anObject
	
	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject.
	self target: anObject! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:12'!
statusSelector

		^ statusSelector! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:12'!
statusSelector: anObject
	
		statusSelector := anObject! !

!ToogleIconicButton methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 4/12/2011 16:31'!
update: aSymbol

	aSymbol = self statusSelector
		ifTrue: [ self updateStatus ].
	super update: aSymbol! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 16:37'!
updateStatus

	self getStatus
		ifTrue: [
			self enabledIcon
				ifNotNil: [:icon |
					 self labelGraphic: icon ]]
		ifFalse: [
			self disabledIcon
				ifNotNil: [:icon | 
					self labelGraphic: icon ]].! !

DialogWindow subclass: #NautilusPluginManager
	instanceVariableNames: 'pluginClassesSelectedIndex pluginClassesSelected pluginsSelected pluginsSelectedIndex pluginsList tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-Manager'!

!NautilusPluginManager methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/25/2011 12:54'!
addButtonAction
	
	self selectedPluginClasses do: [:each | 
		self pluginsList addLast: { each. each defaultPosition } ].
	tree update: #rootNodes! !

!NautilusPluginManager methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 15:47'!
addButtonLabel
	
	^ 'Add'! !

!NautilusPluginManager methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 15:50'!
addButtonState
	
	^ self selectedPluginClasses isEmpty not! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/11/2011 15:56'!
applyChanges
	
	Nautilus pluginClasses: self pluginsList! !

!NautilusPluginManager methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/11/2011 15:42'!
buildAddButton

	^  (PluggableButtonMorph
			on: self 
			getState: #addButtonState
			action: #addButtonAction
			label: #addButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusPluginManager methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/11/2011 14:52'!
buildButtonsColumn

	| column fill |
	column := PanelMorph new.
	column 
		changeTableLayout;
		listDirection: #topToBottom.
		
		{
			self buildFullUpButton.
			self buildUpButton.
			self buildDownButton.
			self buildFullDownButton} reverse do: [:each | column addMorph: each ].
	
	column 
		vResizing: #spaceFill;
		width: 24;
		hResizing: #rigid.
	
	^ column! !

!NautilusPluginManager methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/11/2011 14:48'!
buildDownButton

	^ IconicButton new 
		target: self;
		actionSelector: #down;
		labelGraphic: (self iconClass iconNamed: #down);
		color: Color transparent;
		extent: 24 @ 24;
		borderWidth: 0! !

!NautilusPluginManager methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/11/2011 14:48'!
buildFullDownButton

	^ IconicButton new 
		target: self;
		actionSelector: #fullDown;
		labelGraphic: (self iconClass iconNamed: #downFull);
		color: Color transparent;
		extent: 24 @ 24;
		borderWidth: 0! !

!NautilusPluginManager methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/11/2011 14:12'!
buildFullUpButton

	^ IconicButton new 
		target: self;
		actionSelector: #fullUp;
		labelGraphic: (self iconClass iconNamed: #upFull);
		color: Color transparent;
		extent: 24 @ 24;
		borderWidth: 0! !

!NautilusPluginManager methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/11/2011 15:49'!
buildPluginClassesBox

	^ GroupboxMorph new
			addContentMorph: self buildPluginClassesList;
			addContentMorph: self buildAddButton;
			label: 'Available plugin classes:';
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!NautilusPluginManager methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/25/2011 14:19'!
buildPluginClassesList

	| list |
	list := PluggableListMorph
		on: self
		list: #getPluginClassesList
		primarySelection: #pluginClassesSelectedIndex
		changePrimarySelection: #pluginClassesSelectedIndex:
		listSelection: #pluginClassesSelectedAt:
		changeListSelection: #pluginClassesSelectedAt:put:
		menu: nil
		keystroke: nil.
		
	list wrapSelector: #pluginName.
		
	list resetListSelector: #resetPluginClassesListSelection.
	list autoDeselect: true.
	
	list
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	^ list! !

!NautilusPluginManager methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/11/2011 15:49'!
buildPluginsBox

	^ GroupboxMorph new
			addContentMorph: self buildPluginsList;
			addContentMorph: self buildRemoveButton;
			label: 'Selected plugins:';
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!NautilusPluginManager methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/25/2011 12:51'!
buildPluginsList
	
	tree := (self treeClass model: self) buildPluginsTree.
	tree
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	
	
	^ tree buildContents! !

!NautilusPluginManager methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/11/2011 15:42'!
buildRemoveButton

	^  (PluggableButtonMorph
			on: self 
			getState: #removeButtonState
			action: #removeButtonAction
			label: #removeButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusPluginManager methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/11/2011 14:33'!
buildUpButton

	^ IconicButton new 
		target: self;
		actionSelector: #up;
		labelGraphic: (self iconClass iconNamed: #up);
		color: Color transparent;
		extent: 24 @ 24;
		borderWidth: 0! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/11/2011 15:57'!
centering
	self left: ((World width / 2) - (self width /2)).
	self top: ((World height / 2) - (self height /2))! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 13:51'!
down

	| list selection firstIndex maxSize |
	list := pluginsList copy.
	maxSize := pluginsList size.
	firstIndex := maxSize.
	selection := self selectedPlugins.
	selection reverse do: [:index || each newIndex |
		each := list at: index.
		firstIndex := index+1 min: firstIndex.
		newIndex := index+1 min: maxSize.
		pluginsList removeAt: index.
		pluginsList add: each beforeIndex: newIndex .
		"set selection"
		].
	self pluginsSelectedIndex: firstIndex.
	
	self changed: #getPluginsList.
	self changed: #allSelections.! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 13:51'!
fullDown

	| list selection |
	list := pluginsList copy.
	selection := self selectedPlugins.
	selection doWithIndex: [:idx :count || each |
		each := list at: idx.
		pluginsList removeAt: idx-count+1.
		pluginsList addLast: each].

	self changed: #getPluginsList.
	self changed: #allSelections.! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 13:52'!
fullUp

	| list selection maxSize |
	list := pluginsList copy.
	selection := self selectedPlugins.
	selection reverse doWithIndex: [:idx :count || each |
		each := list at: idx.
		pluginsList removeAt: (idx+count-1).
		pluginsList addFirst: each].
	
	self changed: #getPluginsList.
	self changed: #allSelections.! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 11:22'!
getPluginClassesList

	^ AbstractNautilusPlugin allSubclasses sort: [:a :b | a name <= b name ]! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 8/25/2011 12:48'!
getPluginsList

	^ pluginsList ifNil: [ pluginsList := Nautilus pluginClasses copy ].! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/11/2011 14:13'!
iconClass

	^ NautilusIcons! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/11/2011 13:39'!
initialize

	super initialize.
	pluginClassesSelected := Dictionary new.
	pluginsSelected := Dictionary new.! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/11/2011 13:45'!
isResizeable
	^true! !

!NautilusPluginManager methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/11/2011 14:13'!
newContentMorph

	| container |
	container := PanelMorph new.
	container 
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight.
	
	container 
		vResizing: #spaceFill;	
		hResizing: #spaceFill.
		
	container addMorph: self buildButtonsColumn.
	container addMorph: self buildPluginsBox.
	container addMorph: self buildPluginClassesBox.
	
	^ container! !

!NautilusPluginManager methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/11/2011 15:57'!
openInWorld

	super openInWorld.
	self width: 500.
	self height: 400.
	self centering! !

!NautilusPluginManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2011 15:51'!
pluginClassesSelected

		^ pluginClassesSelected! !

!NautilusPluginManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2011 15:51'!
pluginClassesSelected: anObject
	
		pluginClassesSelected := anObject! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 11:24'!
pluginClassesSelectedAt: anIndex

	| object |
	object := self getPluginClassesList at: anIndex ifAbsent: [ ^ false ].
	^ pluginClassesSelected at: object ifAbsent: [ false ]! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 11:25'!
pluginClassesSelectedAt: anIndex put: aBoolean

	| object |
	object := self getPluginClassesList at: anIndex ifAbsent: [ ^ self ].
	^ pluginClassesSelected at: object put: aBoolean! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 11:23'!
pluginClassesSelectedIndex

	^ pluginClassesSelectedIndex ifNil: [ pluginClassesSelectedIndex := 0 ]! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 14:26'!
pluginClassesSelectedIndex: anInteger

	pluginClassesSelectedIndex := anInteger.
	self changed: #pluginClassesSelectedIndex.! !

!NautilusPluginManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2011 15:51'!
pluginsList

		^ pluginsList! !

!NautilusPluginManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2011 15:51'!
pluginsList: anObject
	
		pluginsList := anObject! !

!NautilusPluginManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2011 15:51'!
pluginsSelected

		^ pluginsSelected! !

!NautilusPluginManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2011 15:51'!
pluginsSelected: anObject
	
		pluginsSelected := anObject! !

!NautilusPluginManager methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 8/25/2011 13:50'!
pluginsSelectedIndex: anIndex! !

!NautilusPluginManager methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/25/2011 14:14'!
removeButtonAction
	
	self selectedPlugins reverse do: [:item || index |
		self pluginsList remove: item ].
	
		self resetPluginsListSelection.
		tree selectionRemoveAll.
		tree model setSelection: nil.
		tree update: #rootNodes! !

!NautilusPluginManager methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 15:47'!
removeButtonLabel
	
	^ 'Remove'! !

!NautilusPluginManager methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 15:49'!
removeButtonState
	
	^ self selectedPlugins isEmpty not! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 13:25'!
resetPluginClassesListSelection

	pluginClassesSelected removeAll! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 13:33'!
resetPluginsListSelection

	pluginsSelected removeAll! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 15:56'!
selectedPluginClasses

	| associations list |
	list := self getPluginClassesList.
	pluginClassesSelected ifNil: [ ^ {} ].
	associations := pluginClassesSelected associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	associations := associations sort: [:a : b | (list indexOf: a ifAbsent: [ 0 ]) <= (list indexOf: b ifAbsent: [ 0 ])].
	^ associations select: [:each | each notNil ]! !

!NautilusPluginManager methodsFor: 'lists behavior' stamp: 'BenjaminVanRyseghem 8/25/2011 13:55'!
selectedPlugins

	^ tree selectedMorphList collect:[:each | each complexContents item ]! !

!NautilusPluginManager methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/11/2011 11:28'!
title

	^ 'Nautilus Plugins Manager'! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 11:11'!
treeClass

	^ NautilusPluginManagerTree! !

!NautilusPluginManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 13:52'!
up

	| list selection firstIndex |
	list := pluginsList copy.
	firstIndex := pluginsList size.
	selection := self selectedPlugins.
	selection do: [:index || each newIndex |
		each := list at: index.
		firstIndex := index-1 min: firstIndex.
		newIndex := index-1 max: 1.
		pluginsList removeAt: index.
		pluginsList add: each beforeIndex: newIndex .
		].
	
	self pluginsSelectedIndex: firstIndex.
	
	self changed: #getPluginsList.
	self changed: #allSelections.! !

!MenuRegistration methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 3/31/2011 01:45'!
enabled: aBoolean

	self spec enabled: aBoolean! !

!MenuRegistration methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 3/31/2011 01:50'!
enabledBlock: aBlock

	self spec enabledBlock: aBlock! !

MorphTreeNodeModel subclass: #PluginTreeNode
	instanceVariableNames: 'selectedPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-Manager'!

!PluginTreeNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 14:56'!
buildDropListFor: aSelector

	| dropList |
	dropList :=  self theme
					newDropListIn: World
					for: self
					list: #getPositionsList
					getSelected: #getSelectedPosition
					setSelected: #setSelectedPosition:
					getEnabled: nil
					useIndex: true
					help: 'Select the position where the plugin will be displayed'.
	dropList
		hResizing: #rigid.
	dropList width: 75.
	^ dropList! !

!PluginTreeNode methodsFor: 'morphs' stamp: 'BenjaminVanRyseghem 8/25/2011 14:17'!
firstMorph

	^ self item 
		ifNotNil: [:it | it first pluginName asStringMorph ]! !

!PluginTreeNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 15:04'!
getPositionsList

	^ self item 
		ifNil: [ {} ]
		ifNotNil: [:it | it first possiblePositions ]! !

!PluginTreeNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 14:50'!
getSelectedPosition

	^ selectedPosition ifNil: [| it |
		it := self item ifNotNil: [ self item second ].
		selectedPosition := self getPositionsList indexOf: it ]! !

!PluginTreeNode methodsFor: 'morphs' stamp: 'BenjaminVanRyseghem 8/25/2011 14:22'!
secondMorph
	
	^ self item 
		ifNotNil: [:it |	self buildDropListFor: it second ]! !

!PluginTreeNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 14:59'!
setSelectedPosition: anIndex

	| position |
	selectedPosition := anIndex.
	position := self getPositionsList at: anIndex.
	self item at: 2 put: position.
	self changed: #getSelectedPosition! !

MorphTreeModel subclass: #NautilusPluginManagerTree
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-Manager'!

!NautilusPluginManagerTree class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 8/25/2011 11:10'!
model: aModel
	
	^ self new model: aModel! !

!NautilusPluginManagerTree methodsFor: 'building' stamp: 'BenjaminVanRyseghem 8/25/2011 14:02'!
buildPluginsTree
	| tree | 
	tree := (IdentityMorphTreeMorph on: self) 
			columns: {
					MorphTreeColumn new startWidth: 100;
						rowMorphGetSelector: #firstMorph;
						headerButtonLabel: 'Plugin name' font:  nil.
					MorphTreeColumn new startWidth: 75;
						rowMorphGetSelector: #secondMorph;
						headerButtonLabel: 'Position' font:  nil};
			withHLines: true;
	
			"doubleClickSelector: #doubleClick;"
			beMultiple;
			"keystrokeActionSelector: #keyStroke:;"
			autoDeselection: false;
			rowInset: 4;
			columnInset: 4;
			getMenuSelector: #menu:shifted:;
			rowColorForEven: Color lightGray muchLighter odd: Color white.

	^ tree! !

!NautilusPluginManagerTree methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/25/2011 11:09'!
model

	^ model! !

!NautilusPluginManagerTree methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/25/2011 11:09'!
model: anObject
	
	model := anObject! !

!NautilusPluginManagerTree methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 8/25/2011 12:49'!
rootItems

	^ self model getPluginsList! !

!NautilusPluginManagerTree methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 8/25/2011 10:44'!
rootNodeClassFromItem: anItem
	^ PluginTreeNode! !

!NautilusPluginManagerTree methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 8/25/2011 11:22'!
update

	self changed: #rootNodes! !

!RGClassDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 9/1/2011 14:28'!
compile: aString classified: aCategory notifying: aController

	self realClass compile: aString classified: aCategory notifying: aController! !

!RGClassDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 9/1/2011 14:18'!
definition

	^ self realClass definition! !

!RGClassDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/28/2011 18:33'!
inheritsFrom: aClass

	^ self realClass inheritsFrom: aClass! !

!RGMetaclassDefinition methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/29/2011 21:23'!
inheritsFrom: aClass

	^ self realClass inheritsFrom: aClass! !

!RecentMessageList methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 3/27/2011 21:08'!
lastClasses: anInteger

	"I return the last anInteger classes modified"
	| result tempList |
	result := OrderedCollection new.
	tempList := self methodReferenceList copy sort: [:a :b | a timeStamp >= b timeStamp].
	
	tempList do: [:method || class |
		result size = anInteger ifTrue: [^result].
		class := method actualClass theNonMetaClass.
		(result includes: class) ifFalse: [result add: class]].
	^ result! !

!UndefinedObject methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/27/2011 22:49'!
asRingDefinition
	
	^ self! !

SystemAnnouncer subclass: #NautilusAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Announcements'!

SystemAnnouncer subclass: #TestAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-TestCaseAnnouncements'!

PragmaMenuBuilder subclass: #NautilusPragmaMenuBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon'!

!NautilusPragmaMenuBuilder methodsFor: 'registrations handling' stamp: 'BenjaminVanRyseghem 4/11/2011 19:07'!
collectRegistrations
	"Retrieve all pragma methods and evaluate them by passing the 
	MenuRegistration class as argument. The result is a list of trees
	stored in my itemList inst var"
	self pragmaCollector
		do: [:prg | self
				currentRoot: self
				while: [ model perform: prg selector with: (MenuRegistration owner: self)]].
! !

!TestCase class methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 4/7/2011 18:37'!
correspondingClass

	(self name endsWith: 'Test')
		ifTrue: [| index na symbol class |
			index := self name findString: 'Test'.
			na := self name copyFrom: 1 to: (index - 1) .
			symbol := Symbol readFromString: '#',na.
			^ Smalltalk at: symbol ifAbsent: [ nil ]].
	^ nil! !

!TestCase class methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/21/2011 11:25'!
hasErrorTest

	^ (self history at: #errors) isEmpty not ! !

!TestCase class methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/21/2011 11:24'!
hasFailedTest

	^ (self history at: #failures) isEmpty not ! !

!TestCase class methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/21/2011 11:24'!
hasPassedTest

	^ (self history at: #passed) isEmpty not ! !

!TestCase class methodsFor: '*NautilusCommon-TestCaseAnnouncements' stamp: 'BenjaminVanRyseghem 5/31/2011 15:07'!
history: aDictionary

	history := aDictionary.
	TestAnnouncer announcer announce: (ATestHasBeenRun result: self)! !

Object subclass: #AbstractNautilusPlugin
	instanceVariableNames: 'model position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

AbstractNautilusPlugin subclass: #AbstractKeyPressedPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

!AbstractKeyPressedPlugin methodsFor: 'announcement' stamp: 'BenjaminVanRyseghem 5/4/2011 15:05'!
keyPressed: anAnnouncement

	self subclassResponsibility! !

!AbstractKeyPressedPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 5/4/2011 15:12'!
registerTo: aModel

	aModel announcer
		on: NautilusKeyPressed send: #keyPressed: to: self! !

AbstractKeyPressedPlugin subclass: #DummyKeyPressedPlugin
	instanceVariableNames: 'stringMorph counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

!DummyKeyPressedPlugin class methodsFor: 'position' stamp: 'BenjaminVanRyseghem 8/25/2011 10:01'!
defaultPosition

	^ #bottom! !

!DummyKeyPressedPlugin methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/10/2011 16:43'!
display

	^ stringMorph! !

!DummyKeyPressedPlugin methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 17:55'!
initialize

	super initialize.
	counter := 0.
	self stringMorph
		contents: 'Keys pressed: ', counter printString;
		openInWorld.
	! !

!DummyKeyPressedPlugin methodsFor: 'announcement' stamp: 'BenjaminVanRyseghem 5/10/2011 17:55'!
keyPressed: anAnnouncement

	| key |
	key := anAnnouncement key.
	counter := counter +1.
	self stringMorph contents: 'Keys pressed: ', counter printString! !

!DummyKeyPressedPlugin methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 17:12'!
stringMorph

		^ stringMorph ifNil: [ stringMorph := LabelMorph new
												enabled:false; 
												vResizing: #shrinkWrap;
												hResizing: #spaceFill;
												yourself]! !

!DummyKeyPressedPlugin methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/4/2011 14:56'!
stringMorph: anObject
	
		stringMorph := anObject! !

AbstractKeyPressedPlugin subclass: #KonamiCodePlugin
	instanceVariableNames: 'lastKeystrokeTime lastKeystrokes code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

!KonamiCodePlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/12/2011 17:22'!
initialize

	super initialize.
	lastKeystrokeTime := 0.
	! !

!KonamiCodePlugin methodsFor: 'announcement' stamp: 'BenjaminVanRyseghem 5/4/2011 15:35'!
keyPressed: ann

	| aChar milliSeconds slowKeyStroke |

	aChar := ann key keyCharacter.

	milliSeconds := Time millisecondClockValue.
	slowKeyStroke := milliSeconds - lastKeystrokeTime > 500.
	lastKeystrokeTime := milliSeconds.
	slowKeyStroke
		ifTrue: ["forget previous keystrokes and search in following elements"
			lastKeystrokes := aChar asLowercase asString.]
		ifFalse: ["append quick keystrokes but don't move selection if it still matches"
			lastKeystrokes := lastKeystrokes , aChar asLowercase asString.].
	"Get rid of blanks and style used in some lists"
	lastKeystrokes = self konamiCode
		ifTrue: [ self openKonamiCode ].! !

!KonamiCodePlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/4/2011 15:44'!
konamiCode

	^ code ifNil: [
			code := ''.
			{ Character arrowUp. Character arrowUp. Character arrowDown. Character arrowDown. Character arrowLeft. Character arrowRight. Character arrowLeft. Character arrowRight. $b. $a } do: [:char | 
				code := code, char asLowercase asString ].
		code] ! !

!KonamiCodePlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/4/2011 15:55'!
openKonamiCode


	[ 15 timesRepeat: [ 
		Beeper primitiveBeep.
		(Delay forMilliseconds: 50) wait.
		]] fork.
! !

!AbstractNautilusPlugin class methodsFor: 'position' stamp: 'BenjaminVanRyseghem 8/25/2011 10:00'!
defaultPosition

	" should answer the position of the UI "
	"Pick an asnwer among:
		- #top
	""	- #right	""
	""	- #left	""
		- #middle
		- #bottom
		- #none"
		
	^ #none! !

!AbstractNautilusPlugin class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/4/2011 14:43'!
model: aModel

	^ self new model: aModel! !

!AbstractNautilusPlugin class methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/25/2011 14:18'!
pluginName

	^ self name! !

!AbstractNautilusPlugin class methodsFor: 'information' stamp: 'BenjaminVanRyseghem 8/25/2011 09:39'!
possiblePositions

	^ {	#top.
		#middle.
		#bottom.
		#none. }! !

!AbstractNautilusPlugin methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/10/2011 16:13'!
display
	
	" should answer a morphic object ready to be integrated into a NautilusWindow "
	
	^ nil! !

!AbstractNautilusPlugin methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/4/2011 14:43'!
model

		^ model! !

!AbstractNautilusPlugin methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/4/2011 14:44'!
model: anObject
	
		model := anObject.
		self registerTo: anObject! !

!AbstractNautilusPlugin methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/25/2011 14:16'!
name

	^ self class name! !

!AbstractNautilusPlugin methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/25/2011 10:03'!
position

	^ position ifNil: [ position := self class defaultPosition ]! !

!AbstractNautilusPlugin methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/25/2011 09:49'!
position: aPosition
	
	position := aPosition! !

!AbstractNautilusPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 5/4/2011 14:45'!
registerTo: aModel

	self subclassResponsibility! !

AbstractNautilusPlugin subclass: #AbstractPackageSelectedPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

!AbstractPackageSelectedPlugin methodsFor: 'announcement' stamp: 'BenjaminVanRyseghem 5/10/2011 14:39'!
packageSelected: anAnnouncement

	^ self subclassResponsibility! !

!AbstractPackageSelectedPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 5/10/2011 12:35'!
registerTo: aModel

	aModel announcer
		on: NautilusPackageSelected send: #packageSelected: to: self! !

AbstractPackageSelectedPlugin subclass: #DummyPackageSelectedPlugin
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

!DummyPackageSelectedPlugin class methodsFor: 'position' stamp: 'BenjaminVanRyseghem 8/25/2011 10:01'!
defaultPosition

	^ #middle! !

!DummyPackageSelectedPlugin methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/10/2011 17:54'!
display

	morph :=  LabelMorph new 
					contents: '';
					enabled: false;
					vResizing: #shrinkWrap;
					hResizing: #spaceFill;
					yourself.
	^ morph! !

!DummyPackageSelectedPlugin methodsFor: 'announcement' stamp: 'BenjaminVanRyseghem 5/11/2011 11:07'!
packageSelected: anAnnouncement
	
	| package name |
	package := anAnnouncement package.
	name := package name asString.
	package ifNil: [ name := ''].
	morph ifNotNil: [ morph contents: name]! !

AbstractNautilusPlugin subclass: #AlexPlugin
	instanceVariableNames: 'text container textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

!AlexPlugin class methodsFor: 'position' stamp: 'BenjaminVanRyseghem 8/25/2011 10:02'!
defaultPosition

	^ #middle! !

!AlexPlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/21/2011 11:54'!
buildTextMorph

	textMorph := PluggableTextMorph
					on: self
					text: #getText
					accept: nil! !

!AlexPlugin methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/21/2011 11:52'!
display

	^ container! !

!AlexPlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/21/2011 11:43'!
getText

	^ text! !

!AlexPlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/21/2011 12:08'!
initialize
	
	text := ''.
	container := PanelMorph new
					color: Color transparent;
					changeTableLayout;
					cellInset: 8;
					listDirection: #topToBottom;
					cellPositioning: #topLeft;
					hResizing: #shrinkWrap;
					vResizing: #shrinkWrap.
	self buildTextMorph! !

!AlexPlugin methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 8/21/2011 12:08'!
methodSelected: anAnnouncement
	
	anAnnouncement method
		ifNotNil: [:method |
			( method methodClass inheritsFrom: TestCase )
			 	ifTrue: [ text := (method methodClass lookupSelector: #setUp) getSource ]]
		ifNil: [ text := ''] .
	self changed: #getText.
	self updateContainer! !

!AlexPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 8/21/2011 11:49'!
registerTo: aModel

	aModel announcer
		on: NautilusMethodSelected send: #methodSelected: to: self.! !

!AlexPlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/21/2011 12:03'!
updateContainer

	^ text isEmpty
		ifTrue: [ container removeMorph: textMorph.
			container hide ]
		ifFalse: [
			container addMorph: textMorph.
			container show ]! !

AbstractNautilusPlugin subclass: #JannikPlugin
	instanceVariableNames: ''
	classVariableNames: 'DirectCycles GraphCache'
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

JannikPlugin class
	instanceVariableNames: 'firstTime'!

JannikPlugin class
	instanceVariableNames: 'firstTime'!

!JannikPlugin class methodsFor: 'accessing' stamp: 'janniklaval 8/24/2011 14:31'!
DirectCycles

	DirectCycles ifNil:[
		self GraphCache ifNotNil:[DirectCycles := self GraphCache circuits select:[:e | e size = 2]]
	]! !

!JannikPlugin class methodsFor: 'accessing' stamp: 'janniklaval 8/24/2011 14:28'!
DirectCycles: aCollectionOfDirectCycles

	DirectCycles := aCollectionOfDirectCycles! !

!JannikPlugin class methodsFor: 'accessing' stamp: 'janniklaval 8/24/2011 14:26'!
GraphCache

	^ GraphCache! !

!JannikPlugin class methodsFor: 'accessing' stamp: 'janniklaval 8/24/2011 14:26'!
GraphCache: aGraph

	GraphCache := aGraph! !

!JannikPlugin class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 16:00'!
firstTime

	^ firstTime ifNil: [ firstTime := true ]! !

!JannikPlugin class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 16:00'!
firstTime: aBoolean

	firstTime := aBoolean! !

!JannikPlugin class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 14:17'!
pluginName

	^ 'Metrics plugin'! !

!JannikPlugin class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 15:03'!
possiblePositions

	^ { #none }! !

!JannikPlugin methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 8/23/2011 21:20'!
buildIconForPackage: aPackage

	| icon |
	icon := (self isPackageInDirectCycle: aPackage)
		ifTrue: [ 
			( IconicButton new 
				target: self;
				actionSelector: #halt;
				labelGraphic: (self iconClass iconNamed: #alert);
				color: Color transparent;
				extent: 16 @ 16;
				borderWidth: 0) ]
		ifFalse: [
			(self isPackageInCycle: aPackage)
				ifTrue: [ 
					( IconicButton new 
						target: self;
						actionSelector: #halt;
						labelGraphic: (self iconClass iconNamed: #warning);
						color: Color transparent;
						extent: 16 @ 16;
						borderWidth: 0)]
				ifFalse: [ nil ]].
			
	^ icon! !

!JannikPlugin methodsFor: 'private' stamp: 'janniklaval 8/24/2011 14:27'!
computeSCCs
	|algo|
	algo := MalCyclesCoverage new.
	algo nodes: self packages.
	algo edges: self dependenciesBetweenPackages from:#key to:#value.
	algo run.
	self class GraphCache: algo! !

!JannikPlugin methodsFor: 'information' stamp: 'janniklaval 8/24/2011 14:24'!
dependenciesBetweenPackages

	|edges|
	edges := OrderedCollection new.
	self packages do:[:aPackage |
		|toPackages|
		toPackages := (self dependenciesOf: aPackage) collect:[:aClass | aClass package ] as: Set.
		toPackages do:[:aToPackage |
			edges add: (aPackage -> aToPackage)
		]
	].
	^edges! !

!JannikPlugin methodsFor: 'information' stamp: 'BenjaminVanRyseghem 8/23/2011 22:56'!
dependenciesOf: aPackage
	
	| dependencies |

	" inheritance "
	dependencies := OrderedCollection new.
	dependencies addAll: (aPackage definedClasses select: [:class | class superclass package ~= aPackage ]).
	
	"extensions"
	dependencies addAll: aPackage extendedClasses.
	self halt.
	
	"static references"
	dependencies addAll: (aPackage definedClasses select: [:class | ( class allCallsOnIn: (SystemNavigation new browsedEnvironment: self model browsedEnvironment )) collect: [:each | each methodClass ]  ]).
	^ dependencies! !

!JannikPlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/23/2011 21:38'!
iconClass
	
	^ NautilusIcons! !

!JannikPlugin methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 8/24/2011 18:38'!
initializeIcons

	self model packages do: [:package || ui icon |
		ui := self model ui.
		icon := self buildIconForPackage: package.
		icon ifNotNil: [ ui class packagesIconsCache at: package put: icon ]].
	self model ui updatePackageView.
		! !

!JannikPlugin methodsFor: 'testing' stamp: 'janniklaval 8/24/2011 14:38'!
isPackageInCycle: aPackage

	self class GraphCache ifNil:[self class GraphCache: (self computeSCCs)].
	^ self class GraphCache circuits anySatisfy:[:aCycle | aCycle includes: aPackage].! !

!JannikPlugin methodsFor: 'testing' stamp: 'janniklaval 8/24/2011 14:38'!
isPackageInDirectCycle: aPackage

	self class GraphCache ifNil:[self class GraphCache: (self computeSCCs)].
	^ self class DirectCycles anySatisfy:[:aCycle | aCycle includes: aPackage].! !

!JannikPlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/23/2011 21:37'!
packageSelected: aPackage

	self class firstTime
		ifTrue: [ 
			self initializeIcons.
			self class firstTime: false ]
		! !

!JannikPlugin methodsFor: 'information' stamp: 'BenjaminVanRyseghem 8/23/2011 22:11'!
packages

	^ self model packages! !

!JannikPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 8/23/2011 21:46'!
registerTo: aModel

	aModel announcer
		on: NautilusPackageSelected send: #packageSelected: to: self.
		
	SystemAnnouncer announcer
		on: SystemMethodModifiedAnnouncement send: #updateIcon: to: self! !

!JannikPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 8/23/2011 21:46'!
updateIcon: anAnnouncement

	" called when a method is changed "! !

AbstractNautilusPlugin subclass: #MondrianPlugin
	instanceVariableNames: 'subMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

!MondrianPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 8/21/2011 17:31'!
classSelected: anAnnouncement

	| container |
	container := self model ui ifNotNil: [:view | view sourceCodeContainer ] ifNil: [ ^ self] .
	anAnnouncement itemClass
		ifNil: [
			subMorphs ifNil: [ subMorphs := container submorphs ].
			container removeAllMorphs.
			container addMorph: (self remplacementMorphUsing: anAnnouncement)]
		ifNotNil: [
			subMorphs ifNotNil: [
			container removeAllMorphs.
			subMorphs reverse do: [:each | container addMorph: each ]]]! !

!MondrianPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 8/21/2011 16:53'!
registerTo: aModel

	aModel announcer
		on: NautilusClassSelected send: #classSelected: to: self! !

!MondrianPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 8/21/2011 17:03'!
remplacementMorphUsing: anAnnouncement
		
	^ Morph new color: Color blue; yourself! !

AbstractNautilusPlugin subclass: #URLPlugin
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

URLPlugin subclass: #IgorsPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin'!

!IgorsPlugin methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 5/27/2011 15:57'!
buildString

	| mdl |
	mdl := self model.
	
	^ mdl selectedClass
		ifNil: [ '' ]
		ifNotNil: [:class |
			mdl selectedMethod
				ifNil: [ (CommentReference class: class) timeStampString ]
				ifNotNil: [:method | method methodReference timeStampString ]]! !

!URLPlugin class methodsFor: 'position' stamp: 'BenjaminVanRyseghem 8/25/2011 10:03'!
defaultPosition

	^ #middle! !

!URLPlugin methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/11/2011 16:30'!
buildString

	| first string separator |
	separator := ' -> '.
	first := self model showGroups
				ifTrue: [ self model selectedGroup ]
				ifFalse: [ self model selectedPackage ].
	first
		ifNil: [ ^'']
		ifNotNil: [:package | 
			string := package name.
			self model selectedClass
				ifNotNil: [:class |
					string := string,  separator, class name.
					self model selectedCategory 
						ifNotNil: [:category |
							string := string,  separator, category.
							self model selectedMethod
								ifNotNil: [:method | string := string, separator, method selector printString]]]].
	^ string! !

!URLPlugin methodsFor: 'announcement' stamp: 'BenjaminVanRyseghem 5/11/2011 16:23'!
changed: ann
	
	| string |
	string := self buildString.
	morph ifNotNil: [ morph contents: string ]! !

!URLPlugin methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/11/2011 16:21'!
display

	morph :=  LabelMorph new 
					contents: '';
					enabled: false;
					vResizing: #shrinkWrap;
					hResizing: #spaceFill;
					yourself.
	^ morph! !

!URLPlugin methodsFor: 'registration' stamp: 'BenjaminVanRyseghem 5/12/2011 11:25'!
registerTo: aModel

	aModel announcer
		on: NautilusPackageSelected send: #changed: to: self;
		on: NautilusClassSelected send: #changed: to: self;
		on: NautilusGroupSelected send: #changed: to: self;
		on: NautilusCategorySelected send: #changed: to: self;
		on: NautilusMethodSelected send: #changed: to: self;
		on: NautilusShowGroupsChanged send: #changed: to: self.! !

Object subclass: #MalGraphAlgorithm
	uses: MalTGraphBuilder
	instanceVariableNames: 'nodes edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-JannikAlgo'!

MalGraphAlgorithm class
	uses: MalTGraphBuilder classTrait
	instanceVariableNames: ''!

!MalGraphAlgorithm methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:36'!
edges

	^ edges! !

!MalGraphAlgorithm methodsFor: 'accessing' stamp: 'jannik.laval 12/10/2010 23:17'!
findNode: aModel

	^ self nodes detect: [:aNode | aNode model = aModel ]! !

!MalGraphAlgorithm methodsFor: 'initialize-release' stamp: 'simon.denier 7/24/2009 11:35'!
initialize

	nodes := OrderedCollection new.
	edges := OrderedCollection new.! !

!MalGraphAlgorithm methodsFor: 'configuration' stamp: 'simon.denier 9/28/2010 13:18'!
nodeClass

	^ MalGraphNode! !

!MalGraphAlgorithm methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 16:58'!
nodes

	^ nodes! !

!MalGraphAlgorithm methodsFor: 'private' stamp: 'simondenier 2/8/2010 22:40'!
privateEdges: aCollection

	edges := aCollection ! !

!MalGraphAlgorithm methodsFor: 'private' stamp: 'simondenier 2/8/2010 22:39'!
privateNodes: aCollection

	nodes := aCollection ! !

!MalGraphAlgorithm methodsFor: 'running' stamp: 'simon.denier 7/10/2009 18:19'!
run

	self subclassResponsibility ! !

MalGraphAlgorithm subclass: #MalSccExtractor
	instanceVariableNames: 'circuits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-JannikAlgo'!

!MalSccExtractor methodsFor: 'accessing' stamp: 'simon.denier 3/19/2010 23:53'!
addCircuit: aCollectionOfNodes
	
	circuits add: aCollectionOfNodes! !

!MalSccExtractor methodsFor: 'accessing' stamp: 'simon.denier 3/19/2010 23:53'!
circuits
	^ circuits! !

!MalSccExtractor methodsFor: 'accessing' stamp: 'simon.denier 3/19/2010 23:56'!
initialize 

	super initialize.
	circuits := Set new.
! !

!MalSccExtractor methodsFor: 'running' stamp: 'simon.denier 3/19/2010 23:54'!
run

	self subclassResponsibility! !

MalSccExtractor subclass: #MalSccNodeDecomposition
	uses: MalTNormalize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-JannikAlgo'!

MalSccNodeDecomposition class
	uses: MalTNormalize classTrait
	instanceVariableNames: ''!

!MalSccNodeDecomposition methodsFor: 'running' stamp: 'simon.denier 9/28/2010 13:18'!
nodeClass

	^ MalSndNode! !

!MalSccNodeDecomposition methodsFor: 'running' stamp: 'simon.denier 3/20/2010 19:09'!
retrieveCircuit: aNode

	|c n i|
	c := OrderedCollection new.
	i := aNode.
	[ i notNil ] whileTrue: [
		c addFirst: i model.
		i := i bfsAncestor.
	].
	^ c! !

!MalSccNodeDecomposition methodsFor: 'running' stamp: 'simon.denier 3/20/2010 18:09'!
run

	self nodes do: [:n|
		self run: n
	]! !

!MalSccNodeDecomposition methodsFor: 'running' stamp: 'simon.denier 3/20/2010 19:07'!
run: aNode

	| fifo visited ancestors |
	visited := Set new.
	ancestors := aNode previousNodes.
	aNode bfsAncestor: nil.
	fifo := OrderedCollection with: aNode.
	[ancestors isEmpty] whileFalse: [ |p|
		p := fifo removeFirst.
		p nextNodes do: [:next|
			((visited includes: next) or: [fifo includes: next])
				ifFalse: [
					next bfsAncestor: p.
					fifo addLast: next ].
			(ancestors includes: next)
				ifTrue: [ |c|
					c := self retrieveCircuit: next.
					self addCircuit: (self normalize: c).
					ancestors remove: next ]
		].
		visited add: p ]! !

MalGraphAlgorithm subclass: #MalTarjan
	instanceVariableNames: 'stack runningIndex sccs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-JannikAlgo'!

MalTarjan subclass: #MalCyclesCoverage
	uses: MalTNormalize
	instanceVariableNames: 'circuits sccExtractorClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-JannikAlgo'!

MalCyclesCoverage class
	uses: MalTNormalize classTrait
	instanceVariableNames: ''!

!MalCyclesCoverage methodsFor: 'accessing' stamp: 'jl 3/26/2010 13:44'!
circuits
	^ circuits! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'simondenier 3/17/2010 22:33'!
directCircuit: aCollection

	^ self normalize: (OrderedCollection with: aCollection first model with: aCollection second model)! !

!MalCyclesCoverage methodsFor: 'initialization' stamp: 'simon.denier 3/20/2010 19:03'!
initialize

	super initialize.
	self useNodeDecomposition ! !

!MalCyclesCoverage methodsFor: 'accessing' stamp: 'jl 3/26/2010 13:39'!
retrieveCircuitsFromSccExtractor: sccExtractor

	sccExtractor circuits do: [:c |
		circuits add: (c collect: [:n| n model]) ]! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'jl 3/26/2010 13:38'!
run

	super run.
	circuits := OrderedCollection new.
	self stronglyConnectedComponents do: [:scc|
		(scc size > 2) ifTrue: [|sccExtractor|
			sccExtractor := sccExtractorClass new.
			sccExtractor nodes: scc.
			"graph injection remove outgoing edges from SCC"
			sccExtractor edges: scc from: #yourself toAll: #nextNodes.
			sccExtractor run.
			self retrieveCircuitsFromSccExtractor: sccExtractor ].
		(scc size = 2) ifTrue: [
			circuits add: (self directCircuit: scc) ]. "direct circuit"
		]! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'simon.denier 9/28/2010 13:18'!
useCircuitSpan

	sccExtractorClass := MalCircuitSpanningEdges  ! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'simon.denier 9/28/2010 13:18'!
useEdgeDecomposition

	sccExtractorClass := MalSccEdgeDecomposition ! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'simon.denier 9/28/2010 13:18'!
useNodeDecomposition

	sccExtractorClass := MalSccNodeDecomposition ! !

!MalTarjan methodsFor: 'configuration' stamp: 'simon.denier 9/28/2010 13:18'!
nodeClass

	^ MalTarjanNode ! !

!MalTarjan methodsFor: 'running' stamp: 'simon.denier 7/6/2009 16:59'!
putOnStack: aTarjanNode

	stack push: aTarjanNode.
	aTarjanNode inStack: true. "I use a flag to avoid stack access"! !

!MalTarjan methodsFor: 'running' stamp: 'simondenier 2/11/2010 21:55'!
run
	"Tarjan's algorithm to detect strongly connected components (aka cycles) in O(m+n)"
	sccs := OrderedCollection new.
	stack := Stack new.
	runningIndex := 0.
	self nodes do: [ :n | n isTarjanUndefined ifTrue: [ self traverse: n ] ]! !

!MalTarjan methodsFor: 'accessing' stamp: 'simondenier 2/11/2010 21:51'!
stronglyConnectedComponents

	^ sccs ! !

!MalTarjan methodsFor: 'running' stamp: 'simondenier 2/11/2010 21:47'!
traverse: aTarjanNode 
	| pNode component |
	aTarjanNode tarjanIndex: runningIndex.
	aTarjanNode tarjanLowlink: runningIndex.
	runningIndex := runningIndex + 1.
	self putOnStack: aTarjanNode.
	aTarjanNode nextNodes do: [:next | 
		next isTarjanUndefined 
			ifTrue: 
				[ self traverse: next.
				aTarjanNode tarjanLowlink: (aTarjanNode tarjanLowlink min: next tarjanLowlink) ]
			ifFalse: 
				[ next inStack ifTrue: 
					[ aTarjanNode tarjanLowlink: (aTarjanNode tarjanLowlink min: next tarjanIndex) ]]].

	aTarjanNode tarjanIndex = aTarjanNode tarjanLowlink ifTrue: 
		[ component := OrderedCollection new.
		 [pNode := stack pop.
		  pNode popped.
		  component add: pNode ] doWhileFalse: [ pNode = aTarjanNode ].
		 sccs add: component.
		 component do: [:each| 
			each cycleNodes: component ]]! !

Object subclass: #MalGraphNode
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-JannikAlgo'!

!MalGraphNode class methodsFor: 'as yet unclassified' stamp: 'simon.denier 7/6/2009 17:01'!
with: aModel

	^ self new model: aModel! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/8/2009 18:41'!
from: sourceNode! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/8/2009 18:41'!
from: sourceNode edge: anEdge! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
label

	^ 'N '! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
model
	^ model! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
model: aModel

	model := aModel! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
printString

	^ self label, self model printString! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
to: targetNode! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
to: targetNode edge: anEdge! !

MalGraphNode subclass: #MalSndNode
	uses: MalTNodeNode
	instanceVariableNames: 'previousNodes nextNodes visited bfsAncestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Plugin-JannikAlgo'!

MalSndNode class
	uses: MalTNodeNode classTrait
	instanceVariableNames: ''!

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 00:06'!
bfsAncestor
	^ bfsAncestor! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 00:06'!
bfsAncestor: anObject
	bfsAncestor := anObject! !

!MalSndNode methodsFor: 'initialize-release' stamp: 'simon.denier 3/20/2010 19:07'!
initialize

	previousNodes := OrderedCollection new.
	nextNodes := OrderedCollection new.! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 18:06'!
nextNodes
	^ nextNodes! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 18:06'!
nextNodes: anObject
	nextNodes := anObject! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 18:06'!
previousNodes
	^ previousNodes! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 18:06'!
previousNodes: anObject
	previousNodes := anObject! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 00:06'!
visited
	^ visited! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 00:06'!
visited: anObject
	visited := anObject! !

Object subclass: #NautilusIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons Instance'
	poolDictionaries: ''
	category: 'NautilusCommon'!

!NautilusIcons commentStamp: 'lr 7/10/2009 11:12' prior: 0!
Most of these icons come from http://www.famfamfam.com/lab/icons. They are licensed under the Creative Commons Attribution 3.0 License by Mark James.!

!NautilusIcons class methodsFor: 'accessing' stamp: 'lr 3/28/2009 16:15'!
default
   ^ Instance ifNil: [ Instance := self new ]! !

!NautilusIcons class methodsFor: 'accessing' stamp: 'dr 9/4/2008 16:35'!
iconNamed: aSymbol
	^ Icons at: aSymbol ifAbsentPut: [self default perform: aSymbol]! !

!NautilusIcons class methodsFor: 'initialization' stamp: 'lr 3/21/2009 19:49'!
initialize
	Instance := nil.
	Icons := IdentityDictionary new! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 8/23/2011 17:49'!
alert
    ^(Form
	extent: 16@16
	depth: 32
	fromArray: #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 2919235584 2919235584 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255616 4278255616 3338665984 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283633923 4283633923 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255616 4291897863 4291897863 4278255616 3338665984 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283633923 4294914824 4294914824 4283633923 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255616 4291897863 4294914824 4294914824 4291897863 4278255616 3338665984 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283568131 4294914824 4294914824 4294914824 4294914824 4283568131 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255616 4291832327 4294914824 4294914824 4294914824 4294914824 4291832327 4278255616 3338665984 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283502595 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4283502595 4278190080 1207959552 16777215 16777215 16777215 16777215 3338665984 4278255616 4291832327 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4291832327 4278255616 3338665984 16777215 16777215 16777215 1207959552 4278190080 4283437059 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4283437059 4278190080 1207959552 16777215 16777215 3338665984 4278255616 4291766534 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4291766534 4278255616 3338665984 16777215 1207959552 4278190080 4283437059 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4283437059 4278190080 1207959552 3288334336 4278190080 4280813569 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4280813569 4278190080 3321888768 3238068224 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3254845440)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 7/10/2009 11:17'!
announcement
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 168300858 976894522 976888885 34288443 993737531 993722369 959979575 673982238 103889690 87761712 705236742 120273668 87758851 152641799 789920516 959985427 204284436 488586007 34289723 993723152 926613505 168311098 976632635 473311541 1010580540 1007826230 840318012 1010580540 456396046 1010580540 1010580526 623262780 1010580540 1010580540 1010580540 1010580540)
	offset: 0@0)
	colorsFromArray: #(#(0.706 0.788 0.875) #(0.439 0.596 0.761) #(0.545 0.674 0.807) #(0.887 0.934 0.996) #(0.538 0.667 0.804) #(0.423 0.585 0.753) #(0.859 0.918 0.992) #(0.844 0.91 0.992) #(0.577 0.694 0.819) #(0.879 0.93 0.996) #(0.953 0.969 0.98) #(0.663 0.757 0.855) #(0.863 0.922 0.992) #(0.372 0.549 0.733) #(0.71 0.792 0.879) #(0.867 0.926 0.996) #(0.815 0.891 0.992) #(0.361 0.542 0.729) #(0.435 0.592 0.761) #(0.875 0.926 0.996) #(0.827 0.902 0.992) #(0.819 0.894 0.992) #(0.678 0.768 0.863) #(0.49 0.635 0.784) #(0.898 0.941 0.996) #(0.867 0.922 0.996) #(0.482 0.628 0.78) #(0.639 0.741 0.848) #(0.937 0.953 0.973) #(0.815 0.894 0.992) #(0.871 0.926 0.996) #(0.819 0.894 0.988) #(0.941 0.965 0.996) #(0.855 0.914 0.992) #(0.84 0.906 0.992) #(0.91 0.945 0.996) #(0.522 0.655 0.796) #(0.431 0.592 0.757) #(0.745 0.815 0.891) #(0.883 0.934 0.996) #(0.902 0.945 0.996) #(0.458 0.612 0.768) #(0.891 0.937 0.996) #(0.836 0.902 0.992) #(0.894 0.937 0.996) #(0.851 0.914 0.992) #(0.914 0.937 0.965) #(0.831 0.902 0.992) #(0.902 0.941 0.996) #(0.863 0.918 0.992) #(0.365 0.545 0.729) #(0.984 0.988 0.992) #(0.6 0.714 0.831) #(0.906 0.934 0.961) #(0.616 0.721 0.836) #(0.914 0.949 0.996) #(0.992 0.996 0.996) #(0.353 0.534 0.725) #(0.345 0.53 0.721) #(1.0 1.0 1.0)))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 14:10'!
arrowDoubleDown
	^ Form
		extent: 12@6
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 1711418368 4278893824 4278893824 1711418368 16777215 16777215 16777215 16777215 16777215 16777215 1644306688 3540342528 3590744064 4278961664 4278961664 3590744064 3540342528 1644306688 16777215 16777215 16777215 16777215 33554432 3120842496 4278962176 4278962688 4278962688 4278962176 3120842496 33554432 16777215 16777215 16777215 16777215 16777215 402722560 3590744064 4278962688 4278962688 3590744064 402722560 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1308764928 3959984384 3959984384 1308764928 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2315466752 2315466752 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 14:09'!
arrowDoubleUp
	^ Form
		extent: 12@6
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 2315466752 2315466752 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1308764928 3959984384 3959984384 1308764928 16777215 16777215 16777215 16777215 16777215 16777215 16777215 402722560 3590744064 4278962688 4278962688 3590744064 402722560 16777215 16777215 16777215 16777215 16777215 33554432 3120842496 4278962176 4278962688 4278962688 4278962176 3120842496 33554432 16777215 16777215 16777215 16777215 1644306688 3540342528 3590744064 4278961664 4278961664 3590744064 3540342528 1644306688 16777215 16777215 16777215 16777215 16777215 16777215 1711418368 4278893824 4278893824 1711418368 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 13:49'!
arrowDown
	^ Form
		extent: 12@12
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1157900544 3154467840 3154467840 1157900544 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1711483648 4278893824 4278893824 1711483648 16777215 16777215 16777215 16777215 16777215 16777215 1661149440 3624228608 3657853952 4278961664 4278961664 3657853952 3624228608 1661149440 16777215 16777215 16777215 16777215 16777216 3070510592 4278962176 4278962688 4278962688 4278962176 3070510592 16777216 16777215 16777215 16777215 16777215 16777215 352324608 3573966336 4278962688 4278962688 3573966336 352324608 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1258499072 3959984128 3959984128 1258499072 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2315532032 2315532032 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 13:48'!
arrowUp
	^ Form
		extent: 12@12
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 2315532032 2315532032 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1275276288 3959984384 3959984384 1275276288 16777215 16777215 16777215 16777215 16777215 16777215 16777215 369104640 3573967104 4278962688 4278962688 3573967104 369104640 16777215 16777215 16777215 16777215 16777215 16777216 3087288576 4278962176 4278962688 4278962688 4278962176 3087288576 16777216 16777215 16777215 16777215 16777215 1610818304 3540342528 3590744320 4278961664 4278961664 3590744064 3540342528 1610818304 16777215 16777215 16777215 16777215 16777215 16777215 1711483648 4278893824 4278893824 1711483648 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1157900544 3154467840 3154467840 1157900544 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 13:46'!
arrowUpAndDown
	^ Form
		extent: 12@12
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 2315532032 2315532032 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1308830464 3959984128 3959984128 1308830464 16777215 16777215 16777215 16777215 16777215 16777215 16777215 402658560 3590744064 4278962688 4278962688 3590744064 402658560 16777215 16777215 16777215 16777215 16777215 33554432 3120842496 4278962176 4278962688 4278962688 4278962176 3120842496 33554432 16777215 16777215 16777215 16777215 1644372480 3540342528 3590744064 4278961664 4278961664 3590744064 3540342528 1644372480 16777215 16777215 16777215 16777215 16777215 16777215 1711483648 4278893824 4278893824 1711483648 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1711483648 4278893824 4278893824 1711483648 16777215 16777215 16777215 16777215 16777215 16777215 1644372480 3540342528 3590744064 4278961664 4278961664 3590744064 3540342528 1644372480 16777215 16777215 16777215 16777215 33554432 3120842496 4278962176 4278962688 4278962688 4278962176 3120842496 33554432 16777215 16777215 16777215 16777215 16777215 402658560 3590744064 4278962688 4278962688 3590744064 402658560 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1308830464 3959984128 3959984128 1308830464 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2315532032 2315532032 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/28/2009 16:04'!
blank
	^ Form extent: 12 @ 12 depth: 8! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/30/2011 12:44'!
bookIcon
	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 284817913 552924404 0 0 0 0 0 0 0 0 0 817149108 3747766882 4287730065 2679749049 549766340 0 0 0 0 0 0 1086110908 4016202338 4287137928 4288914339 4288914339 4289111718 3216290996 1086505666 0 0 0 816754350 4014952271 4287137928 4289309097 4289769648 4289111718 4288453788 4288453788 4288453788 2947658161 0 814846353 4283782485 4287072135 4288059030 4288059030 4288387995 4289243304 4289309097 4287927444 4287598479 2411050421 1081900156 4283585106 4286611584 4287532686 4287532686 4287466893 4287466893 4287401100 4287401100 4287401100 4288716960 2946868645 3211290728 4288651167 4287269514 4287006342 4287006342 4287006342 4286940549 4286940549 4287203721 4289177511 3483213213 281725642 2677183122 4293190884 4292861919 4289177511 4286874756 4286611584 4286611584 4287006342 4289638062 4020084125 549042617 0 282054607 2677643673 4289572269 4293256677 4292796126 4288980132 4287137928 4290164406 4020215711 816754350 0 0 0 0 551082200 2677643673 4289572269 4293256677 4292401368 4289177511 1085584564 0 0 0 0 0 0 0 551213786 2677643673 4288651167 1623244992 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 8/2/2007 19:32'!
breakpoint
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 437918234 437918234 437918234 437654804 319885069 26 437590295 404100630 100859930 437524241 269290764 100860442 437327375 235736076 67305498 437261581 218893324 67305754 437130258 303174162 84082970 436931081 134678279 196890 437918234 437918234 196890 454761243 454761242 196890 454761243 454761242 196634 454761243 454761242 26)
	offset: 0@0)
	colorsFromArray: #(#(0.349 0.212 0.098) #(0.329 0.2 0.094) #(0.376 0.232 0.109) #(0.694 0.462 0.271) #(0.608 0.271 0.204) #(0.545 0.185 0.113) #(0.784 0.322 0.294) #(0.721 0.023 0.023) #(0.788 0.055 0.055) #(0.848 0.106 0.106) #(0.875 0.137 0.137) #(0.914 0.208 0.208) #(0.953 0.298 0.298) #(0.953 0.318 0.318) #(0.953 0.333 0.333) #(0.953 0.349 0.349) #(0.953 0.365 0.365) #(0.953 0.388 0.388) #(0.922 0.427 0.427) #(0.953 0.482 0.482) #(0.949 0.542 0.538) #(0.957 0.592 0.592) #(0.953 0.624 0.62) #(0.984 0.879 0.879) #(0.988 0.898 0.898) #(0.992 0.918 0.918) #(1.0 1.0 1.0) #( )))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:32'!
byteCodeSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4292664540 4290559164 4289506476 4289506476 4289506476 4289506476 4289703855 4290822336 4292006610 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4292598747 4278717966 4279323720 4279323720 4279323720 4279323720 4279323463 4279318839 4279050528 4279575586 4285494644 4292203989 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278314710 4278675039 4282206793 4292598747 4292664540 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278494874 4279051556 4279051813 4279063631 4278307516 4278321133 4278320876 4279121973 4289835441 4292664540 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4286743170 4291611852 4287598479 4279121202 4278321133 4278321133 4278744429 4286874756 4292664540 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4287335307 4292664540 4289309097 4279185197 4278321133 4278321133 4279129424 4288585374 4292664540 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278557071 4278785043 4278785300 4279188279 4278434477 4278321133 4278303148 4279180058 4292072403 4292664540 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278318564 4278256130 4288059030 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278438074 4279133535 4279133535 4278551675 4278309314 4278321133 4278367913 4278984221 4288914339 4292664540 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4284506208 4288124823 4285757303 4279048472 4278313168 4278321133 4278299551 4282667858 4292664540 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4287335307 4292664540 4292664540 4284901994 4278423172 4278321133 4278317536 4279048472 4292664540 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4286743170 4291743438 4289177511 4280167210 4278308030 4278321133 4278318821 4279180315 4292664540 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278494874 4279051556 4279051812 4279257927 4278427540 4278321133 4278321133 4278365344 4281746756 4292664540 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278319078 4278426512 4279180572 4290624957 4292664540 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4292598747 4278717966 4279323720 4279323720 4279323720 4279323720 4279323720 4279321664 4279183656 4278785043 4283061845 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4292664540 4290888129 4289967027 4289967027 4289967027 4289967027 4289967027 4290361785 4291611852 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:37'!
byteCodeUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4290032820 4288322202 4287401100 4287401100 4287401100 4287401100 4287598479 4288519581 4289506476 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4289967027 4278782217 4281084972 4281084972 4281084972 4281084972 4281019179 4280427042 4279571733 4279769112 4284374622 4289638062 4290032820 4290032820 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4285756275 4281742902 4281874488 4289967027 4290032820 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4283782485 4279703319 4279769112 4281216558 4284835173 4286611584 4286545791 4280295456 4287730065 4290032820 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4285229931 4289177511 4285887861 4280163870 4286611584 4286611584 4282203453 4285295724 4290032820 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4285690482 4290032820 4287269514 4280032284 4286611584 4286611584 4281216558 4286677377 4290032820 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4283387727 4279045389 4279111182 4280427042 4284308829 4286611584 4284308829 4279374354 4289506476 4290032820 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286282619 4278321666 4286282619 4290032820 4290032820 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4284835173 4281808695 4281808695 4282664004 4285098345 4286611584 4284243036 4279440147 4286940549 4290032820 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4283321934 4286348412 4284506208 4279308561 4285558896 4286611584 4283848278 4282335039 4290032820 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4285690482 4290032820 4290032820 4283782485 4282861383 4286611584 4286151033 4279308561 4290032820 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4285229931 4289309097 4287137928 4280295456 4284900966 4286611584 4286282619 4279374354 4290032820 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4283782485 4279703319 4279769112 4281019179 4283453520 4286611584 4286611584 4283914071 4281545523 4290032820 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286348412 4283321934 4279440147 4288387995 4290032820 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4289967027 4278782217 4281084972 4281084972 4281084972 4281084972 4281084972 4280821800 4279834905 4279045389 4282598211 4288124823 4290032820 4290032820 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4290032820 4288585374 4287795858 4287795858 4287795858 4287795858 4287795858 4288124823 4289177511 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:57'!
classVarsSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292598747 4290822336 4288585374 4286677377 4287795858 4289572269 4292467161 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292532954 4286414209 4278979864 4279111728 4279046746 4278389373 4278783848 4279177799 4279111452 4284045925 4292269782 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4292664540 4292664540 4291282887 4280361518 4278915157 4278259429 4278259967 4278259967 4278259967 4278259967 4278259967 4278259694 4278980405 4289638062 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4292664540 4292664540 4281677379 4278455444 4278259967 4278259967 4278258881 4279243853 4279045668 4279111722 4279178063 4278324393 4279243848 4289638062 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4292664540 4287072138 4278914886 4278259967 4278259967 4278587028 4279900967 4288716960 4291940817 4291611852 4289045925 4281808966 4278255874 4289967027 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4292664540 4280427316 4278259153 4278259967 4278259689 4279111454 4291677645 4292664540 4292664540 4292664540 4292664540 4292664540 4291414473 4292664540 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4292664540 4278782484 4278259964 4278259967 4278258333 4284177251 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4290953922 4279243312 4278259967 4278259967 4278586741 4287072135 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4290888129 4279243313 4278259967 4278259967 4278652533 4287072135 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4292598747 4278782484 4278259964 4278259967 4278258333 4284243044 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4292664540 4280361523 4278259156 4278259967 4278259689 4279177247 4291743438 4292664540 4292664540 4292664540 4292664540 4292664540 4291743438 4292664540 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4292664540 4286677381 4278914891 4278259967 4278259967 4278587025 4280032555 4289177511 4292072403 4291611852 4289045925 4282335309 4278321667 4290098613 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4292664540 4292664540 4281414207 4278389916 4278259967 4278259967 4278258876 4279243851 4278914077 4279111717 4279243852 4278324129 4279243591 4289638062 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4292664540 4292664540 4291151301 4280032553 4278915165 4278259690 4278259967 4278259967 4278259967 4278259967 4278259967 4278259699 4279046200 4289638062 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292467161 4285953658 4278979863 4279243319 4279112545 4278520965 4278849651 4279243855 4279045659 4283651166 4292269782 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292401368 4290361785 4288124823 4286282619 4287335307 4289111718 4292269782 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:57'!
classVarsUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289967027 4288519581 4286677377 4285164138 4286019447 4287466893 4289835441 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289967027 4285032552 4279242768 4280032284 4281479730 4282400832 4281808695 4280821800 4279374354 4283387727 4289703855 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4290032820 4290032820 4288914339 4280361249 4281216558 4285756275 4286611584 4286611584 4286611584 4286611584 4286611584 4286019447 4280163870 4287598479 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4281545523 4283190348 4286611584 4286611584 4284572001 4281019179 4279637526 4279834905 4281084972 4283782485 4280887593 4287598479 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4290032820 4285558896 4280690214 4286611584 4286611584 4283124555 4280032284 4286808963 4289440683 4289177511 4287072135 4281611316 4278255873 4287861651 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4290032820 4280624421 4285098345 4286611584 4285887861 4279440147 4289243304 4290032820 4290032820 4290032820 4290032820 4290032820 4288980132 4290032820 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4290032820 4279045389 4286479998 4286611584 4283387727 4283321934 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4288651167 4280098077 4286611584 4286611584 4282203453 4285493103 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4288585374 4280163870 4286611584 4286611584 4282203453 4285493103 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4289967027 4279045389 4286479998 4286611584 4283387727 4283453520 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4290032820 4280558628 4285164138 4286611584 4285887861 4279505940 4289309097 4290032820 4290032820 4290032820 4290032820 4290032820 4289309097 4290032820 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4290032820 4285295724 4280887593 4286611584 4286611584 4283058762 4280163870 4287137928 4289572269 4289177511 4287072135 4282071867 4278321666 4287927444 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4290032820 4290032820 4281282351 4283321934 4286611584 4286611584 4284374622 4280953386 4279374354 4279703319 4281019179 4283519313 4280887593 4287598479 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4290032820 4290032820 4288782753 4280098077 4281479730 4285887861 4286611584 4286611584 4286611584 4286611584 4286611584 4286216826 4280361249 4287598479 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289835441 4284703587 4279242768 4280295456 4281677109 4282729797 4282137660 4281150765 4279374354 4282992969 4289703855 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289769648 4288190616 4286348412 4284769380 4285690482 4287137928 4289703855 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:02'!
collection
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 168952850 171324982 909522486 255008812 271977989 285543990 706029348 70649368 724044854 254681884 271986469 689508662 135534100 137758237 890965046 909522486 909513472 436212534 909508866 151126326 909522486 909511457 807338806 909522486 909521969 841353526 909522486 909511458 504824630 909522486 909511943 755436854 909522486 909522486 909522486 909522486)
	offset: 0@0)
	colorsFromArray: #(#(0.565 0.764 0.538) #(0.992 0.98 0.934) #(0.957 0.879 0.549) #(0.953 0.867 0.514) #(1.0 0.569 0.286) #(0.577 0.772 0.553) #(0.557 0.761 0.53) #(0.957 0.875 0.538) #(1.0 0.949 0.914) #(0.937 0.827 0.369) #(1.0 0.953 0.922) #(0.953 0.871 0.53) #(0.542 0.753 0.518) #(0.992 0.98 0.926) #(0.937 0.965 0.934) #(1.0 0.678 0.466) #(1.0 0.667 0.451) #(0.408 0.678 0.372) #(1.0 0.694 0.494) #(0.93 0.961 0.926) #(1.0 0.682 0.478) #(0.918 0.631 0.447) #(1.0 0.557 0.271) #(0.848 0.757 0.384) #(0.545 0.745 0.506) #(0.561 0.686 0.522) #(0.392 0.671 0.357) #(0.466 0.659 0.423) #(0.887 0.53 0.298) #(0.514 0.71 0.474) #(0.807 0.737 0.458) #(0.887 0.796 0.423) #(0.91 0.628 0.443) #(0.93 0.84 0.466) #(0.894 0.804 0.435) #(0.831 0.553 0.372) #(0.823 0.542 0.357) #(0.643 0.772 0.604) #(0.804 0.733 0.443) #(0.871 0.588 0.408) #(0.498 0.698 0.462) #(0.612 0.733 0.573) #(1.0 0.577 0.306) #(0.639 0.764 0.6) #(0.926 0.569 0.337) #(0.937 0.823 0.353) #(0.937 0.581 0.349) #(0.419 0.686 0.388) #(0.883 0.811 0.53) #(0.894 0.823 0.534) #(0.848 0.776 0.494) #(0.973 0.612 0.38) #(0.941 0.831 0.384) #(0.573 0.694 0.534) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:33'!
decompileSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4291217094 4289506476 4289506476 4289506476 4289638062 4290361785 4290953922 4292269782 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4280890147 4280567056 4280830993 4280830993 4280764945 4280434192 4280103695 4279311371 4280034838 4284573533 4290888129 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4284612353 4284612353 4284612353 4284612353 4284612353 4284214785 4282029316 4279377164 4287138439 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4284016385 4281430026 4281430793 4281897729 4283288321 4284612353 4284612353 4284016641 4279708172 4289177511 4292664540 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4281941557 4287335307 4285230697 4280626975 4280701707 4284413441 4284612353 4283354113 4279968790 4292072403 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292598747 4284112983 4281430793 4284612353 4284612353 4281232137 4287006342 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292664540 4292269782 4279376653 4284546305 4284612353 4282427393 4284179031 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292664540 4292664540 4281088036 4283751937 4284612353 4283552769 4281548588 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292664540 4292664540 4280956707 4283817729 4284612353 4283552769 4281614381 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292664540 4292203989 4279310860 4284612097 4284612353 4282427393 4284179031 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292598747 4284047190 4281497096 4284612353 4284612353 4281232137 4287072135 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4281941557 4287335307 4285230697 4280561182 4280899852 4284413697 4284612353 4283354625 4279968790 4292072403 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4284016385 4281430026 4281430793 4281897729 4283288321 4284612353 4284612353 4284082433 4279839757 4289177511 4292664540 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4284612353 4284612353 4284612353 4284612353 4284612353 4284148993 4281896708 4279509005 4287138439 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4280955940 4280567056 4280830993 4280830993 4280764945 4280434192 4280103695 4279311115 4280100631 4284705119 4290888129 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4291414473 4289967027 4289967027 4289967027 4290098613 4290559164 4291085508 4292269782 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:39'!
decompileUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4288848546 4287401100 4287401100 4287401100 4287598479 4288124823 4288651167 4289703855 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4280624421 4280821800 4281084972 4281084972 4281019179 4280558628 4280163870 4279308561 4279900698 4283519313 4288585374 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286019447 4283190348 4279440147 4285558896 4290032820 4290032820 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4285822068 4282071867 4282203453 4283058762 4284900966 4286611584 4286611584 4285822068 4279834905 4287203721 4290032820 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4281413937 4285690482 4284045657 4280361249 4281150765 4286282619 4286611584 4284900966 4279834905 4289572269 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4289967027 4283124555 4282137660 4286611584 4286611584 4281940281 4285361517 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4290032820 4289703855 4279374354 4286545791 4286611584 4283716692 4283190348 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4290032820 4290032820 4280821800 4285493103 4286611584 4285164138 4281150765 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4290032820 4290032820 4280756007 4285558896 4286611584 4285164138 4281216558 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4290032820 4289638062 4279308561 4286545791 4286611584 4283716692 4283190348 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4289967027 4283190348 4282203453 4286611584 4286611584 4281940281 4285427310 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4281413937 4285690482 4284045657 4280361249 4281413937 4286348412 4286611584 4284966759 4279834905 4289572269 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4285822068 4282071867 4282203453 4283058762 4284900966 4286611584 4286611584 4285887861 4279966491 4287203721 4290032820 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286019447 4282992969 4279505940 4285558896 4290032820 4290032820 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4280690214 4280821800 4281084972 4281084972 4281019179 4280558628 4280163870 4279308561 4279966491 4283650899 4288585374 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4288980132 4287795858 4287795858 4287795858 4287927444 4288322202 4288716960 4289703855 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/31/2011 17:27'!
dirtyPackageIcon

	^ (Form
		extent: 15@16
		depth: 32
		fromArray:    #(16777215 16777215 16777215 16777215 16777215 16777215 55924053 417994005 50331647 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 33554432 465965843 3031638305 3903537987 3402577205 1055007009 55924053 16777215 16777215 16777215 16777215 16777215 16777215 33554432 211096853 2898203925 3903533104 4286542707 4286545791 4286874242 4037368410 3520342827 602025004 75530368 16777215 16777215 16777215 67108864 1907822094 3651740708 4254094677 4107417399 4122498132 4286807935 4189741923 4141438293 4238769019 3970982755 2898412355 399008868 41975936 50331648 3569165862 4155256623 4285098345 4285690482 4286019447 4239415384 4242881853 4191310675 4287269514 4287730065 4288848546 4290879648 4140590437 212511402 16777215 3417454134 4220740451 4173088326 4254618194 4106502465 4123936326 4287004286 4189741923 4141438550 4239162492 4191255676 4207711637 4057304204 284159983 16777215 3433903670 4285164138 4285754990 4240068945 4190259015 4287196782 4286545791 4286939521 4173685089 4258814040 4288185990 4288585374 3989996162 234881023 16777215 3618122282 4284571744 4285032552 4154738503 4286280049 4189085535 4190129742 4173682262 4220874350 4123479116 4286743170 4287269514 3990118753 150994943 16777215 3751747873 4218959157 4235610184 4170400322 4285229931 4285558896 4257240919 4285493103 4285822068 4123411524 4288113515 4107945542 4091689787 83886079 16777215 3548454687 4282203453 4233968957 4270077237 4285551186 4284966759 4290072142 4285229931 4286277479 4242418475 4123019079 4286609271 3854453836 83886079 16777216 3664647188 4280756007 4281742902 4284427822 4285086523 4286790202 4289611848 4290390056 4290652200 4291308588 4285690482 4285953654 3870967366 67108863 117440512 3313569037 4263906830 4280163613 4282654238 4282203453 4283319878 4289282112 4286729806 4284900966 4290194476 4285361517 4253703003 3486721317 41975936 16777216 134217728 1603340296 4016639245 4281337864 4280690214 4281611316 4287577405 4284835173 4284835173 4239861543 3820561958 2127435286 75513920 16777215 16777215 16777215 33554432 218103808 2543520266 4149480717 4280424986 4286460980 4285292640 4004129836 2832208402 296026112 16777215 16777215 16777215 16777215 16777215 16777215 16777215 50331648 372899840 3012103437 4187497251 3083409432 565772288 16777216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 134217728 33554432 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 5/11/2011 14:41'!
down
    ^(Form
	extent: 24@24
	depth: 32
	fromArray: #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 251658240 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 251658240 16777215 16777215 16777215 16777215 16777215 1293352960 3894738944 1847590912 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1847590912 3894738944 1293352960 16777215 16777215 16777215 991559680 3846701056 4291952640 3915644928 1562247168 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1562247168 3915644928 4291952640 3846701056 991559680 16777215 16777215 554172416 3694657536 4291624960 4292083712 3881107456 1276837888 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1276837888 3881107456 4292083712 4291624960 3694657536 554172416 16777215 16777215 16777215 738983936 3745382400 4291821568 4292018176 3830054912 1008336896 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1008336896 3830054912 4292018176 4291821568 3745382400 738983936 16777215 16777215 16777215 16777215 16777215 906887168 3796172800 4291952640 4291887104 3779002368 772472832 16777215 16777215 16777215 16777215 16777215 16777215 772472832 3779002368 4291887104 4291952640 3796172800 906887168 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1125318656 3830317056 4292083712 4291690496 3728211968 570949632 16777215 16777215 16777215 16777215 570949632 3728211968 4291690496 4292083712 3830317056 1125318656 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1343881216 3864592384 4292083712 4291428352 3660644352 402653184 16777215 16777215 402653184 3660644352 4291428352 4292083712 3864592384 1343881216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1595604992 3898867712 4292083712 4291035136 3559718912 285212672 285212672 3559718912 4291035136 4292083712 3898867712 1595604992 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1847459840 3949985792 4292083712 4290641920 3458793472 3458793472 4290641920 4292083712 3949985792 1847459840 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2115895296 4001169408 4292083712 4273733632 4273733632 4292083712 4001169408 2115895296 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2367619072 4035510272 4292083712 4292083712 4035510272 2367619072 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2602500096 4103340032 4103340032 2602500096 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2770337792 2770337792 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 5/11/2011 14:42'!
downFull
    ^(Form
	extent: 24@24
	depth: 32
	fromArray: #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 251658240 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 251658240 16777215 16777215 16777215 16777215 16777215 1293352960 3894738944 1847590912 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1847590912 3894738944 1293352960 16777215 16777215 16777215 991559680 3846701056 4291952640 3915644928 1562247168 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1562247168 3915644928 4291952640 3846701056 991559680 16777215 16777215 554172416 3694657536 4291624960 4292083712 3881107456 1276837888 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1276837888 3881107456 4292083712 4291624960 3694657536 554172416 16777215 16777215 16777215 738983936 3745382400 4291821568 4292018176 3830054912 1008336896 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1008336896 3830054912 4292018176 4291821568 3745382400 738983936 16777215 16777215 16777215 16777215 16777215 906887168 3796172800 4291952640 4291887104 3779002368 772472832 16777215 16777215 16777215 16777215 16777215 16777215 772472832 3779002368 4291887104 4291952640 3796172800 906887168 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1125318656 3830317056 4292083712 4291690496 3728211968 570949632 16777215 16777215 16777215 16777215 570949632 3728211968 4291690496 4292083712 3830317056 1125318656 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1343881216 3864592384 4292083712 4291428352 3660644352 402653184 16777215 16777215 402653184 3660644352 4291428352 4292083712 3864592384 1343881216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1595604992 3898867712 4292083712 4291035136 3559718912 285212672 285212672 3559718912 4291035136 4292083712 3898867712 1595604992 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1847459840 3949985792 4292083712 4290641920 3458793472 3458793472 4290641920 4292083712 3949985792 1847459840 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2115895296 4001169408 4292083712 4273733632 4273733632 4292083712 4001169408 2115895296 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2367619072 4035510272 4292083712 4292083712 4035510272 2367619072 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2602500096 4103340032 4103340032 2602500096 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1260322816 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3861184512 3861184512 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 1260322816 16777215 16777215 2552365056 4290772992 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4290772992 2552365056 16777215 16777215 2552365056 4290772992 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4290772992 2552365056 16777215 16777215 2552365056 4290772992 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4292083712 4290772992 2552365056 16777215 16777215 1260322816 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 3089432576 1260322816 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 19:12'!
emptyPackageIcon

	^ (Form
		extent: 14@16
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 33554432 61516458 61516458 16777216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 87241523 1012027986 3211488107 2927262330 613125003 61516458 16777216 16777215 16777215 16777215 16777215 16777216 50331648 541344836 2539346779 4201672816 3530321004 3782637174 4135353468 2407102841 379099288 93952409 16777215 16777215 16777216 252710928 2085704017 3966002276 3344982112 1582519123 109084800 290147147 2070637419 3783097725 3968502410 2323677312 243302528 16777215 67108864 3277478490 4284900966 3797769565 1330071367 138428480 55924053 55924053 208300650 1919576682 4170421139 4272795053 3348008590 164021958 16777215 4134366573 3848824679 3781979244 3681644913 2992857955 1280463442 1365139038 3128325750 3868036493 3851916950 3970081185 3937382319 234881023 16777215 4150749031 3966528620 4268715887 3698224750 4017452405 4252728187 4252991359 3951396229 3599140229 4287203721 4137722016 3903498922 218103807 16777215 4099562074 1684300900 1802004584 3899617135 4184829807 3648550775 3598745471 4202330746 3598548349 1754567828 2492896918 3700790677 150994943 16777215 4047980359 1599625304 16777215 158429553 3261885548 4151604340 4286019190 2557768820 264027324 117440511 2055570821 3531768450 83886079 16777215 4197725236 1750028111 16777215 16777215 2741265508 4167921005 4285756018 1466986608 33554431 50331647 2172419196 3715857275 83886079 16777215 4212989213 3627431478 826820680 16777215 2673235542 3982516063 3698356079 1248422249 16777215 510553710 3178460019 3698816887 67108863 16777215 2586586156 4195751446 4247004196 3091218496 3209185352 4166078544 4235095405 1432774246 2003331176 4134234987 3849351280 1601993852 33554431 16777215 16777215 473183284 3274123047 4263123482 4280953386 4215094589 4285427053 4167394661 3831981927 2188077931 244486802 33554431 16777215 16777215 16777215 16777215 16777215 1093874483 3760267553 4213581093 4268649837 2758108517 492921185 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1832598331 1014528120 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:10'!
exception
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 1583238196 1191577949 759500554 1583225870 390089009 36066088 1578711384 857557019 906518110 1581393173 991970905 1549688414 722677332 570761514 1583242846 1327383559 1091971346 5322527 792346372 337270359 1297099812 1011548469 286015067 654532190 1583242842 941838926 1432247902 1583242763 221384798 1583242846 1583224899 1029594718 1583242846 1583231050 1583242846 1583242846)
	offset: 0@0)
	colorsFromArray: #(#(0.906 0.764 0.392) #(0.945 0.867 0.6) #(0.918 0.776 0.306) #(0.969 0.922 0.815) #(0.945 0.831 0.443) #(0.953 0.84 0.443) #(0.934 0.823 0.388) #(0.953 0.819 0.286) #(0.98 0.949 0.855) #(0.93 0.815 0.376) #(0.992 0.98 0.941) #(0.894 0.733 0.302) #(0.945 0.792 0.4) #(0.898 0.725 0.286) #(0.949 0.863 0.423) #(0.965 0.91 0.737) #(0.984 0.961 0.906) #(0.914 0.772 0.365) #(0.91 0.768 0.384) #(0.941 0.844 0.415) #(0.953 0.844 0.498) #(0.965 0.871 0.4) #(0.953 0.836 0.474) #(0.945 0.859 0.439) #(0.949 0.867 0.651) #(0.988 0.965 0.867) #(0.949 0.815 0.455) #(0.957 0.855 0.542) #(0.953 0.875 0.514) #(0.957 0.836 0.341) #(0.953 0.867 0.474) #(0.914 0.78 0.474) #(0.945 0.8 0.263) #(0.934 0.811 0.431) #(0.941 0.792 0.216) #(0.93 0.788 0.443) #(0.965 0.914 0.796) #(0.965 0.891 0.51) #(0.898 0.733 0.22) #(0.906 0.764 0.435) #(0.992 0.984 0.953) #(0.898 0.737 0.275) #(0.957 0.894 0.71) #(0.992 0.977 0.914) #(0.926 0.815 0.569) #(0.918 0.788 0.333) #(0.973 0.902 0.561) #(0.918 0.788 0.286) #(0.957 0.891 0.725) #(0.937 0.815 0.396) #(0.902 0.757 0.396) #(0.965 0.867 0.369) #(0.937 0.84 0.384) #(0.934 0.836 0.526) #(0.91 0.764 0.306) #(0.887 0.721 0.333) #(0.914 0.764 0.357) #(0.941 0.855 0.412) #(0.949 0.855 0.462) #(0.949 0.811 0.232) #(0.957 0.891 0.635) #(0.945 0.863 0.659) #(0.941 0.776 0.408) #(0.953 0.855 0.474) #(0.945 0.844 0.427) #(0.941 0.78 0.236) #(0.957 0.891 0.608) #(0.875 0.69 0.216) #(0.969 0.883 0.451) #(0.906 0.761 0.286) #(0.957 0.848 0.498) #(0.934 0.836 0.396) #(0.961 0.84 0.415) #(0.941 0.831 0.408) #(0.977 0.941 0.855) #(0.949 0.875 0.604) #(0.965 0.91 0.655) #(0.922 0.757 0.404) #(0.941 0.851 0.635) #(0.965 0.914 0.698) #(0.879 0.69 0.247) #(0.898 0.741 0.353) #(0.891 0.717 0.302) #(0.973 0.934 0.804) #(0.953 0.831 0.279) #(1.0 0.996 0.992) #(0.941 0.796 0.443) #(0.941 0.804 0.486) #(0.98 0.922 0.573) #(0.914 0.772 0.345) #(0.98 0.945 0.859) #(0.902 0.725 0.322) #(0.969 0.918 0.772) #(0.926 0.8 0.357) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 8/2/2007 19:32'!
flag
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 437918234 437918234 437918234 436470535 101584139 387389210 436404481 17105924 303634202 436666638 218827016 35198490 437126412 185075720 1644314 437060363 168298504 1644570 436930320 269422351 370743322 437326099 320082453 387520538 437918234 437918234 387520538 454761243 454761242 387520538 454761243 454761242 387520282 454761243 454761242 387389210)
	offset: 0@0)
	colorsFromArray: #(#(0.22 0.396 0.585) #(0.898 0.945 0.996) #(0.228 0.498 0.761) #(0.608 0.796 0.98) #(0.635 0.804 0.98) #(0.655 0.819 0.98) #(0.47 0.729 0.973) #(0.542 0.768 0.977) #(0.251 0.631 0.961) #(0.267 0.639 0.961) #(0.275 0.643 0.961) #(0.286 0.647 0.961) #(0.302 0.659 0.965) #(0.326 0.667 0.965) #(0.353 0.678 0.965) #(0.396 0.714 0.965) #(0.419 0.729 0.969) #(0.239 0.686 0.93) #(0.243 0.624 0.772) #(0.236 0.682 0.851) #(0.228 0.667 0.788) #(0.224 0.616 0.671) #(0.384 0.228 0.082) #(0.349 0.212 0.098) #(0.329 0.2 0.094) #(0.694 0.462 0.271) #(1.0 1.0 1.0) #( )))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 18:50'!
greenArrowUpAndDown
	^ Form
		extent: 9@15
		depth: 32
		fromArray:  #(16777215 16777215 16777215 906042112 3791859456 906042112 16777215 16777215 16777215 16777215 16777215 268435456 3557049600 4278962432 3557049600 268435456 16777215 16777215 16777215 16777216 3137548288 4278894336 4278962688 4278894336 3137548288 16777216 16777215 16777215 2348951296 4161381376 4278962688 4278962688 4278962688 4161381376 2348951296 16777215 1342316032 3926358272 4278962688 4278962688 4278962688 4278962688 4278962688 3926358272 1342316032 3858831104 3842402048 3842402048 4262115584 4278962688 4262115584 3842402048 3842402048 3858831104 251658240 268435456 1140850688 4194866688 4278962688 4194866688 1140850688 268435456 251658240 16777215 16777215 939524096 4194866688 4278962688 4194866688 939524096 16777215 16777215 251658240 268435456 1140850688 4194866688 4278962688 4194866688 1140850688 268435456 251658240 3858831104 3842402048 3842402048 4262115584 4278962688 4262115584 3842402048 3842402048 3858831104 1342316032 3926358272 4278962688 4278962688 4278962688 4278962688 4278962688 3926358272 1342316032 16777215 2348951296 4161381376 4278962688 4278962688 4278962688 4161381376 2348951296 16777215 16777215 16777216 3137548288 4278894336 4278962688 4278894336 3137548288 16777216 16777215 16777215 16777215 268435456 3557049600 4278962432 3557049600 268435456 16777215 16777215 16777215 16777215 16777215 906042112 3791859456 906042112 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/1/2011 15:26'!
groupIcon

	^ (Form
		extent: 15@16
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 16777215 741343023 3275816768 3075604305 610139997 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 206881045 2468937512 4198039352 4282777413 4283629394 4133486431 2422472547 160417763 16777215 16777215 16777215 16777215 16777215 16777215 1593774888 3892256563 3483734080 3963682109 4282777413 4283563857 3915905900 3816339156 3866464511 1668517887 16777215 16777215 16777215 704196930 3271492893 4294906665 4294909748 4294913088 4143399757 3482178394 3546861469 4234117372 4285237503 4286026495 4286881023 3448151551 544905471 16777215 2212050759 3705883738 3892062268 4294909748 4261359168 3506413903 4043306825 3959223899 3718624710 4285237503 4286026495 3933375999 3813831421 1295737599 16777215 2261264440 4291180100 4225057616 3505218398 3640584759 4294965305 4294965317 4294965585 4294965598 3673156994 3613359861 4248921854 4282673663 1329686527 16777215 2327257906 4289868607 4290721090 3821495878 4041136203 3623152977 4294965316 4261411153 3623876694 4110415943 4015421164 4283133695 4283988479 1397584383 16777215 2255301983 4187107390 4289344061 3887095105 4291281462 4292070714 4007252563 3942249295 4294965308 4294965575 4050224622 4284448511 4068575729 1386704574 16777215 2467771800 4146608763 3898423902 3969339963 4289900083 4290820917 4274767168 4294965068 4294965582 4294965594 4051670252 3704655548 4194271886 1526686578 16777215 2567710594 4279970659 4280431990 4180689000 4269180974 4289439538 4290491968 4294965343 4294965602 4173456753 4058746767 4294936466 4294939806 1593798010 67108864 2919241572 4278982722 4279641432 4280168537 4280713254 4282219052 4288322877 4292864882 4286898294 4286775170 4276918936 4294941604 4294944944 1694069631 83886080 1879052875 4177530951 4278653495 4279377983 4279984923 4280448802 4282093368 4287035781 4287299466 4288151447 4277119914 4294946743 3824456348 669148016 16777216 150994944 587202568 3288339543 4227928107 4279059213 4279654422 4281433136 4288216727 4288610206 4289462187 4109085865 2195417203 150994944 16777216 16777215 16777215 33554432 234881024 1207970826 3858781696 4278664199 4280771878 4289396393 4255841706 3111708280 407587627 33554432 16777215 16777215 16777215 16777215 16777215 16777215 67108864 352321536 2046839040 4028261914 3734040464 1028699728 67108864 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 117440512 251658240 117440512 16777216 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:56'!
instVarsSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4289506476 4289506476 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4290361785 4279634185 4283175185 4283175185 4279568649 4290427578 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4290361785 4279634185 4283175185 4283175185 4279568649 4290427578 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4290361785 4289967027 4289967027 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:56'!
instVarsUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287861651 4287401100 4287401100 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4288124823 4279045389 4281084972 4281084972 4279045389 4288190616 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4288124823 4279045389 4281084972 4281084972 4279045389 4288190616 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4288190616 4287795858 4287795858 4288190616 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:19'!
magnitude
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 874447653 738461995 85013556 875824136 573444634 471217204 875826957 607204404 875115572 875836464 489816628 875836468 875836468 50409268 875836468 875836468 268902708 875836468 875836418 101004340 875836468 875836448 167851060 873804852 875825163 204747815 874722356 875763995 321259818 335557684 875042605 102243847 930868 875836468 875836468 875836468)
	offset: 0@0)
	colorsFromArray: #(#(0.372 0.372 0.372) #(0.608 0.608 0.608) #(0.961 0.961 0.961) #(0.506 0.506 0.506) #(0.588 0.588 0.588) #(0.415 0.415 0.415) #(0.419 0.419 0.419) #(0.384 0.384 0.384) #(0.745 0.745 0.745) #(0.561 0.561 0.561) #(0.447 0.447 0.447) #(0.435 0.435 0.435) #(0.427 0.427 0.427) #(0.545 0.545 0.545) #(0.522 0.522 0.522) #(0.902 0.902 0.902) #(0.761 0.761 0.761) #(0.53 0.53 0.53) #(0.686 0.686 0.686) #(0.628 0.628 0.628) #(0.181 0.181 0.181) #(0.204 0.204 0.204) #(0.604 0.604 0.604) #(0.455 0.455 0.455) #(0.408 0.408 0.408) #(0.341 0.341 0.341) #(0.659 0.659 0.659) #(0.333 0.333 0.333) #(0.663 0.663 0.663) #(0.624 0.624 0.624) #(0.396 0.396 0.396) #(0.875 0.875 0.875) #(0.542 0.542 0.542) #(0.592 0.592 0.592) #(0.569 0.569 0.569) #(0.236 0.236 0.236) #(0.565 0.565 0.565) #(0.494 0.494 0.494) #(0.62 0.62 0.62) #(0.953 0.953 0.953) #(0.733 0.733 0.733) #(0.502 0.502 0.502) #(0.298 0.298 0.298) #(0.451 0.451 0.451) #(0.585 0.585 0.585) #(0.439 0.439 0.439) #(0.698 0.698 0.698) #(0.714 0.714 0.714) #(0.721 0.721 0.721) #(0.855 0.855 0.855) #(0.474 0.474 0.474) #(0.871 0.871 0.871) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:13'!
morph
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 1578631802 292362797 539127618 1895825665 2117994270 1445606482 202325275 1997372285 33573212 859313989 1763509875 1213866361 1064308758 192424752 1645101626 793665883 476466020 85208644 1751792704 621947215 1414349622 527711064 676669009 1346794755 1617375851 1095982919 656635516 1819423020 354700362 1695037706 154613091 420699479 75263577 2139062143 2139062143 2139062143)
	offset: 0@0)
	colorsFromArray: #(#(0.557 0.714 0.898) #(0.526 0.686 0.887) #(0.557 0.706 0.887) #(0.494 0.604 0.796) #(0.494 0.6 0.792) #(0.585 0.811 1.0) #(0.879 0.93 0.883) #(0.514 0.671 0.867) #(0.84 0.867 0.902) #(0.581 0.667 0.804) #(0.474 0.577 0.753) #(0.729 0.851 0.674) #(0.51 0.678 0.883) #(0.565 0.71 0.918) #(0.733 0.894 1.0) #(0.538 0.694 0.883) #(0.455 0.741 1.0) #(0.553 0.69 0.871) #(0.969 0.867 0.78) #(0.506 0.635 0.815) #(0.757 0.906 1.0) #(0.851 0.879 0.922) #(0.655 0.844 1.0) #(0.836 0.918 0.992) #(0.604 0.741 0.902) #(0.518 0.631 0.804) #(0.542 0.678 0.855) #(0.549 0.698 0.883) #(0.753 0.875 0.725) #(0.815 0.894 0.823) #(0.51 0.667 0.863) #(0.639 0.733 0.91) #(0.522 0.659 0.84) #(0.686 0.757 0.867) #(0.542 0.671 0.836) #(1.0 0.949 0.612) #(0.848 0.859 0.894) #(0.988 0.949 0.918) #(1.0 0.682 0.514) #(0.984 0.871 0.415) #(1.0 0.796 0.674) #(0.977 0.914 0.867) #(0.518 0.671 0.859) #(0.585 0.776 0.518) #(0.836 0.879 0.922) #(0.534 0.671 0.851) #(0.706 0.757 0.855) #(0.643 0.745 0.879) #(0.819 0.918 1.0) #(0.827 0.871 0.906) #(0.458 0.721 0.404) #(0.62 0.737 0.891) #(0.51 0.631 0.8) #(0.577 0.663 0.848) #(0.506 0.612 0.776) #(0.565 0.671 0.84) #(0.926 0.961 0.992) #(0.581 0.659 0.792) #(0.545 0.639 0.792) #(0.4 0.686 0.353) #(0.811 0.898 0.827) #(0.561 0.706 0.883) #(0.518 0.674 0.871) #(0.659 0.757 0.891) #(0.887 0.945 0.902) #(1.0 0.84 0.717) #(0.717 0.776 0.863) #(0.678 0.745 0.859) #(0.538 0.628 0.776) #(0.898 0.945 0.992) #(1.0 0.918 0.549) #(0.996 0.961 0.757) #(0.863 0.93 0.992) #(0.474 0.628 0.827) #(0.844 0.871 0.914) #(0.62 0.807 0.581) #(0.848 0.867 0.91) #(0.988 0.977 0.898) #(0.804 0.914 1.0) #(0.98 0.977 0.934) #(0.957 0.84 0.365) #(0.961 0.93 0.714) #(0.596 0.678 0.815) #(1.0 0.6 0.314) #(0.953 0.937 0.823) #(1.0 0.538 0.243) #(0.502 0.659 0.855) #(0.498 0.596 0.768) #(0.549 0.792 0.577) #(0.612 0.682 0.807) #(0.914 0.957 0.992) #(0.706 0.863 1.0) #(0.482 0.616 0.8) #(0.498 0.624 0.792) #(0.694 0.757 0.863) #(1.0 0.737 0.569) #(0.631 0.721 0.902) #(0.522 0.772 1.0) #(0.549 0.792 1.0) #(0.553 0.647 0.823) #(0.836 0.926 1.0) #(0.84 0.863 0.891) #(0.423 0.717 0.423) #(0.788 0.898 0.733) #(0.612 0.729 0.887) #(0.918 0.953 0.922) #(0.934 0.965 0.934) #(0.616 0.831 0.628) #(0.53 0.643 0.807) #(0.545 0.686 0.863) #(0.502 0.596 0.753) #(0.616 0.702 0.823) #(0.772 0.898 1.0) #(0.581 0.686 0.844) #(0.851 0.891 0.934) #(0.937 0.965 0.992) #(0.729 0.859 0.686) #(0.671 0.745 0.879) #(0.682 0.749 0.879) #(0.545 0.698 0.898) #(0.388 0.682 0.341) #(0.534 0.639 0.8) #(0.561 0.702 0.883) #(0.553 0.706 0.91) #(0.486 0.588 0.776) #(0.542 0.698 0.887) #(0.522 0.678 0.875) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/30/2011 19:10'!
packageIcon

	^ (Form
		extent: 15@16
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 16777215 55924053 75530368 50331647 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 33554432 138428480 1750488662 3547295599 2256173690 261724569 55924053 16777215 16777215 16777215 16777215 16777215 16777215 33554432 103492395 1178944837 3361890914 4286085240 4286545791 4286808963 3900275065 1819834488 162179754 75530368 16777215 16777215 16777215 67108864 741618740 2874693720 4235029869 3514399097 3783229311 4286677377 4119234182 3499200913 4203580813 3683026566 1736672131 245671076 41975936 50331648 1902206815 3948896095 4285098345 4285690482 4286019447 4185685116 3213527690 3817441673 4287269514 4287730065 4288848546 4289638062 3180762774 212511402 16777215 2523490665 4084692598 3631641716 4235161455 3497621881 3783229311 4286677377 4119299975 3482555283 4203778192 3919684001 4004358826 3786387375 284159983 16777215 2556847718 4285164138 4285558896 3665656699 3732371319 4286151033 4286545791 4286808963 3968502410 3515912079 4287532686 4288585374 3701974951 234881023 16777215 2639878489 4284506208 4285032552 3715067759 4285822068 3850272125 3883761021 3632563075 4202527868 3582034305 4286743170 4287269514 3583218579 150994943 16777215 2672643405 3863957327 4200291163 3814941539 4285229931 4285558896 4185421687 4285493103 4285822068 3564928124 4286414205 3498542983 3196421509 83886079 16777215 2822651454 4282203453 4182395466 4081929549 4284374622 4284966759 4268715630 4285229931 4285493103 3698027371 3698948473 4286282619 3480976251 83886079 16777216 3039636781 4280756007 4281742902 4265360444 4283058762 4283519313 4284966502 4284243036 4266939476 4233977181 4285690482 4285953654 3480647286 67108863 117440512 2518687776 4246148887 4280098077 4280821800 4282203453 4282992969 4284374365 4284637794 4284900966 4267071062 4285361517 4235095662 2305452650 41975936 16777216 134217728 873731092 3659670050 4245885715 4280690214 4281611316 4283913814 4284835173 4284835173 4065744470 3294255706 844255826 55924053 16777215 16777215 16777215 33554432 218103808 1461131031 3978305568 4280098077 4249635659 4284835173 3730463322 1246514252 100663296 16777215 16777215 16777215 16777215 16777215 16777215 16777215 50331648 285212672 2115903006 3645129539 1833979984 150994944 16777216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 134217728 33554432 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/30/2011 14:23'!
refreshIcon
	^(Form
		extent: 16@16
		depth: 32
		fromArray: #( 0 0 0 0 0 0 0 895969127 526080859 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1884706390 4168710521 2288675434 271330348 0 0 0 0 0 0 0 0 0 828465505 2609087363 3615917702 4269439610 4285887861 4285624689 3899156584 1766607948 67569415 0 0 0 0 0 50529027 2306242166 4237069452 4286940549 4286611584 4286282619 4285887861 4285558896 4285229931 4268189543 2235514687 0 0 0 0 0 2590862701 4287598479 4287269514 4270097540 3329652342 3312217196 4285887861 4285558896 3345179491 1011567435 0 0 0 0 0 1263423054 4287532686 4287532686 3867378563 1096835168 0 1885166941 3681579120 1549227863 50923785 0 0 0 0 0 0 3061545851 4287795858 4236937866 811951461 0 0 641547581 137441585 0 0 0 0 0 0 0 34936085 4102720138 4287795858 3011016824 0 0 0 0 0 0 0 0 0 0 0 0 272317243 4287861651 4287795858 2489607268 0 0 0 0 0 0 0 0 68095759 0 0 0 204682035 4287730065 4287795858 2658432116 0 0 0 0 0 0 0 34014983 3965146967 4283979864 3125694030 0 0 3767044232 4287795858 3884287365 137244206 0 0 0 0 0 0 1129863256 4284769380 4284506208 2739423304 0 0 2189459584 4287795858 4287532686 2541123190 16843009 0 0 0 0 305805882 3597166696 4284703587 4250885983 910114623 0 0 273698896 3834218889 4287532686 4287335307 3094442353 1094532413 101255433 286199567 1582124365 3731318631 4284966759 4284703587 2689946965 0 0 0 0 879126118 3985082247 4287269514 4286940549 4286611584 4285624689 4285558896 4285624689 4285229931 4284966759 3227212635 220998700 0 0 0 0 0 509698401 2977659771 4286743170 4286545791 4286282619 4285887861 4285558896 4100417383 2170116441 103295016 0 0 0 0 0 0 0 0 575820370 1734895720 2121298032 2037017194 1448564567 255013683 0 0 0 0 0)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/31/2011 01:59'!
removeIcon
	^ (Form
	extent: 16@16
	depth: 32
	fromArray:  #(0 0 0 0 0 16777216 975118106 1948196125 2233408797 505551386 0 0 0 0 0 0 0 0 0 740105501 2485067036 3913366574 4287266903 4291870588 4290358386 4234896198 2770871586 723394078 0 0 0 0 0 169482778 2803834139 4266346036 4290226543 4292129381 4291006529 4287127849 4290939191 4289826121 4292857218 4270292053 3056281379 991829530 0 0 0 2048727835 4289170770 4293777803 4291932517 4286537258 4278912771 4278190080 4279044356 4285747232 4289428791 4293645446 4293515148 4285162053 1461525786 0 0 2233014039 4292059214 4291203136 4290485594 4293186183 4288648552 4283518790 4284439625 4290950264 4292989063 4292791942 4294041488 4289240168 2535004182 0 0 1141837583 4079033886 4283716440 4291862608 4291794755 4292721001 4294896278 4294436244 4293515404 4294436244 4291016058 4286086513 4079889188 1712262925 0 0 134217728 3676117787 4280495698 4280627542 4282731358 4290877268 4294104192 4289439097 4284839294 4283921301 4284976569 4284516277 2786662166 469762048 0 0 0 3407682073 4283195017 4283194246 4282338678 4281351266 4282406780 4283791527 4284188861 4284124357 4283993287 4282936985 2249528595 0 0 0 0 3122338329 4283195018 4283194246 4283194246 4283194246 4283198876 4283927751 4283927751 4283927751 4283927751 4282408577 1746145553 0 0 0 0 2837125656 4283063944 4283194246 4283194246 4283194246 4283463079 4283927751 4283927751 4283927751 4283927751 4281880424 1225657870 0 0 0 0 2518292504 4282932356 4283194246 4283194246 4283194246 4283594409 4283927751 4283927751 4283927751 4283927751 4264641108 688260614 0 0 0 0 2199459607 4282800510 4283194246 4283194246 4283194246 4283395998 4283927751 4283927751 4283927751 4283927751 4062984519 436207616 0 0 0 0 1192366610 4248059475 4283195017 4283194246 4283194246 4283066516 4283927751 4283927751 4283927751 4283729855 3676448299 285212672 0 0 0 0 67108864 1494289934 3827639852 4282932356 4283194246 4282803083 4283927751 4283729598 4282408577 4230492216 2434077971 67108864 0 0 0 0 0 0 503908617 2887325720 4265496687 4282340983 4281682014 4062323235 2836928279 1225394698 268435456 0 0 0 0 0 0 0 0 67108864 1662326034 2904102936 2216105237 604440327 67108864 0 0 0 0 0)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:45'!
separatorIcon

	^ (Form
		extent: 24@5
		depth: 32
		fromArray: #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1329216058 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1329216058 3869089181 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 3869089181 1329216058 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1329216058 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:02'!
sourceSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray:  #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4290559164 4288322202 4286677377 4287072135 4288059030 4289835441 4292401368 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4292664540 4292664540 4290756543 4282860089 4280753420 4284695566 4286534405 4286140423 4284826893 4282330640 4279504905 4283386433 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4292664540 4291940817 4280688920 4288702210 4294812161 4294943489 4294943489 4294943489 4294943489 4294943489 4294812161 4279570699 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4292664540 4286018931 4285877510 4294943489 4294615041 4285417737 4281739280 4280293645 4282002192 4284695307 4290081793 4279570699 4292664540 4292664540 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4292664540 4283188796 4290738689 4294943489 4287848196 4283386692 4290822336 4292467161 4290822336 4287598479 4282728245 4282202159 4292664540 4292664540 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4292664540 4282201643 4291921409 4294943489 4288110851 4282136625 4289177511 4292401368 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4292664540 4284702552 4288045315 4294943489 4294746369 4288833538 4283053328 4279767818 4281609506 4285821550 4290822336 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4292664540 4290822336 4280096525 4291724289 4294943489 4294943489 4294943489 4294943489 4292381185 4287257092 4280227852 4286281843 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4292664540 4292664540 4289309097 4280623127 4283119119 4288702210 4292841217 4294943489 4294943489 4294943489 4293892353 4281541901 4289111718 4292664540 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292467161 4288914339 4284570966 4281280541 4280885005 4287651076 4294943489 4294943489 4289950209 4283912520 4292664540 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4292664540 4291480266 4291151301 4292664540 4292664540 4292664540 4292664540 4290690750 4281412643 4291198721 4294943489 4292249857 4282004264 4292664540 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4292664540 4283386174 4279373319 4283123260 4288322202 4290822336 4292467161 4290032820 4280886300 4291330049 4294943489 4290410241 4283583554 4292664540 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4292664540 4283385916 4290607361 4289884673 4284235791 4281673744 4279702025 4281870608 4287388937 4294943489 4294943489 4285549063 4286282360 4292664540 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4292664540 4283385916 4288176385 4294680577 4294943489 4294943489 4294943489 4294943489 4294943489 4294877697 4288636418 4280754713 4292072403 4292664540 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4292664540 4288979874 4282465072 4279702026 4283184655 4285089547 4286862853 4286534407 4284367117 4280819213 4282925625 4290756543 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292138196 4289309097 4287927444 4286479998 4286743170 4288453788 4290822336 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:01'!
sourceUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray:  #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4288322202 4286479998 4285164138 4285493103 4286282619 4287730065 4289769648 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4290032820 4290032820 4288453788 4281742902 4279703319 4281742902 4282532418 4282335039 4281808695 4280624421 4278979596 4282137660 4290032820 4290032820 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4290032820 4289440683 4279966491 4283519313 4286545791 4286611584 4286611584 4286611584 4286611584 4286611584 4286545791 4279111182 4290032820 4290032820 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4290032820 4284506208 4282203453 4286611584 4286414205 4282071867 4280295456 4279571733 4280427042 4281677109 4284177243 4279111182 4290032820 4290032820 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4290032820 4281940281 4284506208 4286611584 4283124555 4282269246 4288519581 4289901234 4288519581 4285887861 4281545523 4281216558 4290032820 4290032820 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4290032820 4281084972 4285098345 4286611584 4283190348 4281216558 4287137928 4289769648 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4290032820 4283256141 4283124555 4286611584 4286479998 4283585106 4280953386 4279176975 4280624421 4284308829 4288519581 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4290032820 4288519581 4279440147 4284966759 4286611584 4286611584 4286611584 4286611584 4285295724 4282861383 4279505940 4284637794 4290032820 4290032820 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4290032820 4290032820 4287269514 4279900698 4280953386 4283519313 4285558896 4286611584 4286611584 4286611584 4286085240 4280163870 4287137928 4290032820 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289835441 4286940549 4283256141 4280361249 4279834905 4283058762 4286611584 4286611584 4284111450 4282532418 4290032820 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4290032820 4289045925 4288782753 4290032820 4290032820 4290032820 4290032820 4288387995 4280558628 4284703587 4286611584 4285229931 4280887593 4290032820 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4290032820 4282071867 4278979596 4281940281 4286479998 4288519581 4289835441 4287927444 4280163870 4284769380 4286611584 4284308829 4282269246 4290032820 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4290032820 4282071867 4284440415 4284045657 4281545523 4280229663 4279176975 4280361249 4282927176 4286611584 4286611584 4282071867 4284769380 4290032820 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4290032820 4282071867 4283190348 4286479998 4286611584 4286611584 4286611584 4286611584 4286611584 4286545791 4283453520 4279966491 4289572269 4290032820 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4290032820 4287006342 4281413937 4279176975 4280953386 4281874488 4282664004 4282532418 4281545523 4279834905 4281742902 4288453788 4290032820 4290032820 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289638062 4287269514 4286151033 4284966759 4285229931 4286611584 4288519581 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:19'!
string
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 673716502 100672805 623061032 673717016 118757928 587409448 673710082 33825576 354166824 673717518 268698408 19277864 673714447 504037672 638134312 673720360 302655016 606152744 673720360 673588264 555886632 673720360 673456424 572991528 673720360 671621672 656418856 673720360 673654568 538912808 673720360 671948840 84682792 673720360 673128232 320284712)
	offset: 0@0)
	colorsFromArray: #(#(0.439 0.721 0.937) #(0.447 0.674 0.93) #(0.573 0.784 0.953) #(0.451 0.682 0.937) #(0.534 0.761 0.949) #(0.435 0.631 0.926) #(0.439 0.729 0.945) #(0.573 0.788 0.953) #(0.443 0.651 0.926) #(0.443 0.663 0.93) #(0.427 0.671 0.93) #(0.494 0.733 0.945) #(0.431 0.631 0.926) #(0.435 0.643 0.926) #(0.498 0.745 0.945) #(0.478 0.694 0.934) #(0.569 0.78 0.953) #(0.941 0.965 0.992) #(0.941 0.961 0.992) #(0.431 0.628 0.926) #(0.538 0.764 0.949) #(0.447 0.682 0.937) #(0.435 0.706 0.937) #(0.431 0.628 0.918) #(0.522 0.768 0.949) #(0.827 0.898 0.977) #(0.455 0.694 0.937) #(0.419 0.71 0.937) #(0.447 0.682 0.93) #(0.455 0.698 0.937) #(0.443 0.71 0.937) #(0.435 0.635 0.926) #(0.435 0.639 0.926) #(0.443 0.659 0.926) #(0.439 0.651 0.926) #(0.451 0.686 0.937) #(0.443 0.659 0.93) #(0.439 0.717 0.937) #(0.443 0.671 0.93) #(0.435 0.647 0.926) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 17:57'!
testGreen
    ^(Form
	extent: 12@12
	depth: 32
	fromArray:   #(16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215 16777215 436207616 3204448256 4278323202 4280376350 4283209800 4283603789 4281625137 4278454788 3204448256 436207616 16777215 16777216 3204448256 4279053323 4284135253 4285913199 4286964095 4287686539 4287686539 4286173300 4279974425 3204448256 16777216 1694498816 4278390018 4281819188 4281322278 4281584939 4283421512 4286701692 4287686539 4287686539 4286502265 4278718727 1694498816 3003121664 4278532866 4279526927 4278962688 4278962688 4278962688 4280077330 4285521256 4287686539 4287686539 4282680896 3003121664 3858759680 4278596868 4279588369 4278962688 4278962688 4278962688 4278962688 4279880718 4286505081 4287686539 4284724574 3858759680 3858759680 4278596100 4279775511 4279091970 4278962688 4278962688 4278962688 4278962688 4282700348 4286964095 4284330585 3858759680 3003121664 4278531331 4279838232 4280186137 4278962688 4278962688 4278962688 4278962688 4280863775 4285913199 4281432365 3003121664 1694498816 4278258432 4279710997 4280959017 4280909604 4279288326 4278962688 4278962688 4280928544 4284924000 4278718727 1694498816 16777216 3204448256 4278592773 4280634914 4281948471 4282806595 4282814529 4282884930 4284523356 4279448081 3204448256 16777216 16777215 436207616 3204448256 4278257409 4279649811 4280902950 4281167401 4279980312 4278388995 3204448256 436207616 16777215 16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 17:54'!
testNotRun
    ^(Form
	extent: 12@12
	depth: 32
	fromArray:  #(16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215 16777215 436207616 3204448256 4278584838 4282795590 4286348412 4286611584 4283848278 4278716424 3204448256 436207616 16777215 16777216 3204448256 4280295456 4287927444 4289967027 4290690750 4291217094 4291217094 4289703855 4281216558 3204448256 16777216 1694498816 4278782217 4283453520 4287664272 4287861651 4288848546 4290559164 4291217094 4291217094 4290032820 4279111182 1694498816 3003121664 4280756007 4282861383 4286743170 4286743170 4286743170 4287269514 4289967027 4291217094 4291217094 4285361517 3003121664 3858759680 4280492835 4282203453 4286743170 4286743170 4286743170 4286743170 4287137928 4290493371 4291217094 4288059030 3858759680 3858759680 4280361249 4280821800 4286479998 4286743170 4286743170 4286743170 4286743170 4288453788 4290690750 4287795858 3858759680 3003121664 4280492835 4280361249 4283716692 4286743170 4286743170 4286743170 4286743170 4287598479 4289967027 4284374622 3003121664 1694498816 4278650631 4280953386 4281874488 4284440415 4286545791 4286743170 4286743170 4287466893 4288585374 4279111182 1694498816 16777216 3204448256 4279834905 4282269246 4283256141 4284572001 4285822068 4286611584 4287203721 4280756007 3204448256 16777216 16777215 436207616 3204448256 4278519045 4281611316 4283387727 4283782485 4282203453 4278650631 3204448256 436207616 16777215 16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 17:58'!
testRed
    ^(Form
	extent: 12@12
	depth: 32
	fromArray:   #(16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215 16777215 436207616 3204448256 4278714882 4284227102 4288170056 4288367949 4285149489 4278846468 3204448256 436207616 16777215 16777216 3204448256 4281076491 4290205013 4292374383 4292968319 4293364619 4293364619 4291851380 4281997593 3204448256 16777216 1694498816 4279042562 4284494900 4291503654 4291636011 4292036680 4292902012 4293364619 4293364619 4292180345 4279305991 1694498816 3003121664 4282057218 4284878607 4291428352 4291428352 4291428352 4291564050 4292700264 4293364619 4293364619 4286988352 3003121664 3858759680 4281664516 4283830545 4291428352 4291428352 4291428352 4291428352 4291563022 4292901241 4293364619 4290076254 3858759680 3858759680 4281467908 4281407255 4290970114 4291428352 4291428352 4291428352 4291428352 4291968060 4292968319 4289878361 3858759680 3003121664 4281664259 4280686616 4285864217 4291428352 4291428352 4291428352 4291428352 4291567391 4292374383 4286131501 3003121664 1694498816 4278910976 4281668885 4282394921 4286522404 4290905606 4291428352 4291428352 4291371040 4290797664 4279305991 1694498816 16777216 3204448256 4280616197 4283310626 4284036919 4285612867 4287643969 4288889410 4288896092 4281471249 3204448256 16777216 16777215 436207616 3204448256 4278649089 4282782483 4284818982 4285409577 4283504664 4278780675 3204448256 436207616 16777215 16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 17:58'!
testYellow
    ^(Form
	extent: 12@12
	depth: 32
	fromArray:  #(16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215 16777215 436207616 3204448256 4278782211 4285164839 4289375827 4289572953 4286020153 4278913797 3204448256 436207616 16777215 16777216 3204448256 4281545744 4291612771 4293915774 4294376077 4294705048 4294705048 4293191809 4282467102 3204448256 16777216 1694498816 4279176964 4285164603 4293850685 4294047809 4294113371 4294376074 4294705048 4294705048 4293521030 4279505928 1694498816 3003121664 4282862090 4286151963 4294377244 4294377244 4294377244 4294311212 4294376312 4294705048 4294705048 4288059722 3003121664 3858759680 4282335499 4284835867 4294377244 4294377244 4294377244 4294377244 4294311465 4294376327 4294705048 4291349354 3858759680 3858759680 4282072330 4281808922 4293785117 4294377244 4294377244 4294377244 4294377244 4294113616 4294376077 4291218021 3858759680 3003121664 4282467082 4280887578 4287204646 4294377244 4294377244 4294377244 4294377244 4294113847 4293915774 4287270200 3003121664 1694498816 4279111170 4282137882 4282795820 4287862577 4293653536 4294377244 4294377244 4293784887 4292139373 4279505928 1694498816 16777216 3204448256 4281019657 4283914536 4284506684 4286283082 4288783436 4290362703 4289836389 4282006550 3204448256 16777216 16777215 436207616 3204448256 4278716418 4283519770 4285756975 4286415155 4284375328 4278848004 3204448256 436207616 16777215 16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 8/23/2011 18:49'!
trait
    ^(Form
	extent: 16@16
	depth: 32
	fromArray: #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 2919235584 2919235584 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255616 4278255616 3338665984 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283633923 4283633923 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255616 4291897863 4291897863 4278255616 3338665984 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283633923 4294914824 4294914824 4283633923 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255616 4291897863 4294914824 4294914824 4291897863 4278255616 3338665984 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283568131 4294914824 4294914824 4294914824 4294914824 4283568131 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255616 4291832327 4294914824 4294914824 4294914824 4294914824 4291832327 4278255616 3338665984 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283502595 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4283502595 4278190080 1207959552 16777215 16777215 16777215 16777215 3338665984 4278255616 4291832327 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4291832327 4278255616 3338665984 16777215 16777215 16777215 1207959552 4278190080 4283437059 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4283437059 4278190080 1207959552 16777215 16777215 3338665984 4278255616 4291766534 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4291766534 4278255616 3338665984 16777215 1207959552 4278190080 4283437059 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4294914824 4283437059 4278190080 1207959552 3288334336 4278190080 4280813569 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4282322178 4280813569 4278190080 3321888768 3238068224 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3254845440)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 5/11/2011 14:04'!
up
    ^(Form
	extent: 24@24
	depth: 32
	fromArray:  #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1107301120 1107301120 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1006636288 3808439296 3808439296 1006636288 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 805309184 3774883072 4278222336 4278222336 3774883072 805309184 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 637536000 3724550656 4278221824 4278222848 4278222848 4278221824 3724550656 637536000 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 503316480 3674217984 4278221312 4278222848 3841995520 3841995520 4278222848 4278221312 3674217984 503316480 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 385875968 3607108352 4278220800 4278222848 3909105664 1442845184 1442845184 3909105664 4278222848 4278220800 3607108352 385875968 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 285212672 3523221504 4278220032 4278222848 3959439616 1761612544 16777215 16777215 1761612544 3959439616 4278222848 4278220032 3523221504 285212672 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 201326592 3439334912 4278219264 4278222848 4009773568 2046825728 16777215 16777215 16777215 16777215 2046825728 4009773568 4278222848 4278219264 3439334912 201326592 16777215 16777215 16777215 16777215 16777215 16777215 16777215 134217728 3338671360 4261440768 4278222848 4060107264 2365592576 16777215 16777215 16777215 16777215 16777215 16777215 2365592576 4060107264 4278222848 4261440768 3338671360 134217728 16777215 16777215 16777215 16777215 16777215 83886080 3204453376 4244662528 4278222848 4127218176 2634028288 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2634028288 4127218176 4278222848 4244662528 3204453376 83886080 16777215 16777215 16777215 33554432 3053458432 4194329856 4278222848 4177551616 2885686528 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2885686528 4177551616 4278222848 4194329856 3053458432 33554432 16777215 16777215 1509951744 4076880384 4278222848 4227885056 3087013120 33554432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 33554432 3087013120 4227885056 4278222848 4076880384 1509951744 16777215 16777215 33554432 2919240960 4160769280 3271562752 100663296 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 100663296 3271562752 4160769280 2919240960 33554432 16777215 16777215 16777215 33554432 1996492544 167772160 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 167772160 1996492544 33554432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 5/11/2011 14:08'!
upFull
    ^(Form
	extent: 24@24
	depth: 32
	fromArray:  #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 234881024 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 805306368 234881024 16777215 16777215 2483032832 4076880128 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4043327744 4076880128 2483032832 16777215 16777215 2550141952 4278219776 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278219776 2550141952 16777215 16777215 2550141952 4278219776 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278222848 4278219776 2550141952 16777215 16777215 2231374080 3791660032 3741329664 3741329664 3741329664 3741329664 3741329664 3741329664 3741329664 3741329664 3875547136 3875547136 3741329664 3741329664 3741329664 3741329664 3741329664 3741329664 3741329664 3741329664 3791660032 2231374080 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1006636288 3808439296 3808439296 1006636288 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 805309184 3774883072 4278222336 4278222336 3774883072 805309184 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 637536000 3724550656 4278221824 4278222848 4278222848 4278221824 3724550656 637536000 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 503316480 3674217984 4278221312 4278222848 3841995520 3841995520 4278222848 4278221312 3674217984 503316480 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 385875968 3607108352 4278220800 4278222848 3909105664 1442845184 1442845184 3909105664 4278222848 4278220800 3607108352 385875968 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 285212672 3523221504 4278220032 4278222848 3959439616 1761612544 16777215 16777215 1761612544 3959439616 4278222848 4278220032 3523221504 285212672 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 201326592 3439334912 4278219264 4278222848 4009773568 2046825728 16777215 16777215 16777215 16777215 2046825728 4009773568 4278222848 4278219264 3439334912 201326592 16777215 16777215 16777215 16777215 16777215 16777215 16777215 134217728 3338671360 4261440768 4278222848 4060107264 2365592576 16777215 16777215 16777215 16777215 16777215 16777215 2365592576 4060107264 4278222848 4261440768 3338671360 134217728 16777215 16777215 16777215 16777215 16777215 83886080 3204453376 4244662528 4278222848 4127218176 2634028288 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2634028288 4127218176 4278222848 4244662528 3204453376 83886080 16777215 16777215 16777215 33554432 3053458432 4194329856 4278222848 4177551616 2885686528 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2885686528 4177551616 4278222848 4194329856 3053458432 33554432 16777215 16777215 1509951744 4076880384 4278222848 4227885056 3087013120 33554432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 33554432 3087013120 4227885056 4278222848 4076880384 1509951744 16777215 16777215 33554432 2919240960 4160769280 3271562752 100663296 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 100663296 3271562752 4160769280 2919240960 33554432 16777215 16777215 16777215 33554432 1996492544 167772160 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 167772160 1996492544 33554432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 8/23/2011 17:49'!
warning
    ^(Form
	extent: 16@16
	depth: 32
	fromArray: #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 2919235584 2919235584 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255872 4278255872 3338665984 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283643907 4283643907 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255872 4291923463 4291923463 4278255872 3338665984 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283643907 4294946056 4294946056 4283643907 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255872 4291923463 4294946056 4294946056 4291923463 4278255872 3338665984 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283578371 4294946056 4294946056 4294946056 4294946056 4283578371 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278255872 4291857671 4294946056 4294946056 4294946056 4294946056 4291857671 4278255872 3338665984 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4283512579 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4283512579 4278190080 1207959552 16777215 16777215 16777215 16777215 3338665984 4278255872 4291857671 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4291857671 4278255872 3338665984 16777215 16777215 16777215 1207959552 4278190080 4283446787 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4283446787 4278190080 1207959552 16777215 16777215 3338665984 4278255872 4291791878 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4291791878 4278255872 3338665984 16777215 1207959552 4278190080 4283446787 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4294946056 4283446787 4278190080 1207959552 3288334336 4278190080 4280818433 4282329858 4282329858 4282329858 4282329858 4282329858 4282329858 4282329858 4282329858 4282329858 4282329858 4280818433 4278190080 3321888768 3238068224 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3254845440)
	offset: 0@0)! !

Object subclass: #NautilusWrapper
	instanceVariableNames: 'selectedPackage selectedCategory selectedMethod selectedClass selectedGroup showPackages showGroups showHierarchy showComment showInstance showCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon'!

!NautilusWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/13/2011 16:35'!
with: aNautilus

	^ self new with: aNautilus! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedCategory

		^ selectedCategory! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedCategory: anObject
	
		selectedCategory := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedClass

		^ selectedClass! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedClass: anObject
	
		selectedClass := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedGroup

		^ selectedGroup! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedGroup: anObject
	
		selectedGroup := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedMethod

		^ selectedMethod! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedMethod: anObject
	
		selectedMethod := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedPackage

		^ selectedPackage! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedPackage: anObject
	
		selectedPackage := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showCategories

		^ showCategories! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showCategories: anObject
	
		showCategories := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showComment

		^ showComment! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showComment: anObject
	
		showComment := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showGroups

		^ showGroups! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showGroups: anObject
	
		showGroups := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showHierarchy

		^ showHierarchy! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showHierarchy: anObject
	
		showHierarchy := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showInstance

		^ showInstance! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showInstance: anObject
	
		showInstance := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showPackages

		^ showPackages! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 20:15'!
showPackages: anObject
	
	showPackages := anObject! !

!NautilusWrapper methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/12/2011 13:13'!
with: aNautilus
	
	self 
		selectedPackage: aNautilus selectedPackage;
		selectedCategory: aNautilus selectedCategory.
		aNautilus selectedMethod
			ifNil: [ self selectedMethod: nil ]
			ifNotNil: [:met | self selectedMethod: met selector].
	self
		selectedClass: aNautilus selectedClass;
		selectedGroup: aNautilus selectedGroup;
		showPackages: aNautilus showPackages;
		showGroups: aNautilus showGroups;
		showHierarchy: aNautilus showHierarchy;
		showComment: aNautilus showComment;
		showInstance: aNautilus showInstance;
		showCategories: aNautilus showCategories.! !

Object subclass: #Refactor
	instanceVariableNames: 'toMoveInSuperClass addAnAbstractMethodNamed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusCommon-Refactor'!

!Refactor methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 5/24/2011 13:50'!
createAbstractMethods

	addAnAbstractMethodNamed do: [:assoc || sel cat |
		sel := assoc key.
		cat := assoc value.
		AbstractNautilusUI compile: sel, '
	^ self subclassResponsibility' classified: cat]! !

!Refactor methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 5/24/2011 13:02'!
initialize

	super initialize.
	toMoveInSuperClass := OrderedCollection new.
	addAnAbstractMethodNamed := OrderedCollection new.! !

!Refactor methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 5/24/2011 14:03'!
moveDetectedMethods

	toMoveInSuperClass do: [:assoc || key value selector |
		key := assoc key.
		value := assoc value.
		selector := key selector.
		AbstractNautilusUI compile: key getSource classified: key category.
		key methodClass removeSelector: selector.
		value methodClass removeSelector: selector ]! !

!Refactor methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 5/24/2011 13:48'!
script

	self
		detectMethods;
		moveDetectedMethods;
		createAbstractMethods! !

!BrowserEnvironment methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 8/23/2011 22:31'!
asSystemNavigationEnvironment

	| classes env globalsNames |
	classes := self classes.
	env := SystemDictionary new.
	classes do: [:each | 
		env add: ( Smalltalk globals associationAt: each theNonMetaClass name )].
	globalsNames := Smalltalk globals keys asOrderedCollection.
	globalsNames removeAll: ( Smalltalk globals classNames ).
	 globalsNames removeAll: ( Smalltalk globals traitNames ).
	globalsNames do: [:each | 
		env add: ( Smalltalk globals associationAt: each )].
	^ env! !

!BrowserEnvironment methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 3/27/2011 15:45'!
packageOrganizer

	^ RPackageOrganizer default! !

!BrowserEnvironment methodsFor: '*NautilusCommon' stamp: 'BenjaminVanRyseghem 3/22/2011 18:16'!
packages

	^ self packageOrganizer packages! !

!ClassDescription methodsFor: '*NautilusCommon' stamp: 'AlexandreBergel 8/21/2011 17:25'!
correspondingForTest
	"Return the unit test that correspond to me. If it does not exist, it returns myself. 
	 Return the tested class if sent to a class"
	
	| symbol |
	^ (self inheritsFrom: TestCase)
		ifTrue: [ 
			| i |
			i := self name indexOfSubCollection: 'Test'.
			symbol := Symbol readFromString: ('#', self name copyReplaceAll: 'Test' with: '' ).
			Smalltalk at: symbol ifAbsent: [ self ]]
		ifFalse: [
			symbol := Symbol readFromString: ('#', self name, 'Test').
			Smalltalk at: symbol ifAbsent: [ self ]]! !
NautilusIcons initialize!
